/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2009 The LS-Universe Team

  Homepage: http://www.ls-universe.info

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#include "stdafx.h"
#include "GradientRadial.h"
#include <math.h>

GradientRadial::GradientRadial(int width, int height, COLORREF startColor, COLORREF endColor) : Gradient(width, height, startColor, endColor)
{
    radius = sqrt((double) height/2*height/2 + width/2*width/2);
    quadrantGradient();
}

void GradientRadial::paintPixel(DWORD *p, int x, int y)
{
    unsigned char *c = (unsigned char *)p;
    int i = y / 2;
    int j = x / 2;
    double r = sqrt(((i-height/2)/radius)*((i-height/2)/radius) + ((j-width/2)/radius)*((j-width/2)/radius));
    if ( r <= 1.0 )
    {
        c[0] = (unsigned char)(r*GetBValue(colorTo) + (1-r)*GetBValue(colorFrom));
        c[1] = (unsigned char)(r*GetGValue(colorTo) + (1-r)*GetGValue(colorFrom));
        c[2] = (unsigned char)(r*GetRValue(colorTo) + (1-r)*GetRValue(colorFrom));
    }
    else
    {
        c[0] = GetBValue(colorTo);
        c[1] = GetGValue(colorTo);
        c[2] = GetRValue(colorTo);
    }
}