/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2009 The LS-Universe Team

  Homepage: http://www.ls-universe.info

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_PAINTTHUMBNAIL_H__208B32CC_BA27_4498_ADE7_B5E11D79C9C2__INCLUDED_)
#define AFX_PAINTTHUMBNAIL_H__208B32CC_BA27_4498_ADE7_B5E11D79C9C2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef HANDLE HTHUMBNAIL;

class PaintThumbnail  
{
public:
	PaintThumbnail();
	PaintThumbnail(const PaintThumbnailDefaults *pPaintThumbnailDefaults);
	virtual ~PaintThumbnail();

	XPAINTCLASS_API BOOL configure(LPCSTR pszName, LPCSTR pszPrefix, const PaintThumbnail *pDefaultPaintThumbnail = NULL, const PaintThumbnailDefaults *pPaintThumbnailDefaults = NULL);
    
    XPAINTCLASS_API void apply(HWND sourcehWnd, HWND desthWnd, int x = -1, int y = -1, int width = -1, int height = -1);

private:

	HTHUMBNAIL thumbnail;
	bool m_bThumbnailRegistered;

	bool m_bSpecialSetup;

	//*****************************************************************
    // Settings
    //*****************************************************************

    string m_strThumbnail_X;
    string m_strThumbnail_Y;

    string m_strThumbnail_Width;
    string m_strThumbnail_Height;

	int m_iAlphaTransparency;

};

#endif // !defined(AFX_PAINTTHUMBNAIL_H__208B32CC_BA27_4498_ADE7_B5E11D79C9C2__INCLUDED_)
