/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2009 The LS-Universe Team

  Homepage: http://www.ls-universe.info

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

/*
    Resample

    Carlo Pallini, Dec. 2007 

    * AKNOWLEDGMENTS:
  
    This work is based on the Libor Tinka's article "Image Resizing - outperform GDI+" that
    may be found at CodeProject:
    http://www.codeproject.com/KB/GDI-plus/imgresizoutperfgdiplus.aspx
    I've ported his original algo to 100% pure unmanaged C code.
    There are some modification and the resulting code (thought not optimized)
    is a bit faster than the original one.
    
    Dec. 17th 2007
*/

#ifndef _RESAMPLE_H_
#define _RESAMPLE_H_

/* Stock (i.e. already defined) filters */
#define STOCK_FILTER_BELL               0x00000000
#define STOCK_FILTER_BOX                0x00000001
#define STOCK_FILTER_CATMULLROM         0x00000002
#define STOCK_FILTER_COSINE             0x00000003
#define STOCK_FILTER_CUBICCONVOLUTION   0x00000004
#define STOCK_FILTER_CUBICSPLINE        0x00000005
#define STOCK_FILTER_HERMITE            0x00000006                  
#define STOCK_FILTER_LANCZOS3           0x00000007
#define STOCK_FILTER_LANCZOS8           0x00000008
#define STOCK_FILTER_MITCHELL           0x00000009
#define STOCK_FILTER_QUADRATIC          0x0000000A
#define STOCK_FILTER_QUADRATICBSPLINE   0x0000000B
#define STOCK_FILTER_TRIANGLE           0x0000000C

#define STOCK_FILTERS                   0x0000000D

BOOL CreateResampledBitmap(HDC hdc, HBITMAP hBmpSource, DWORD dwWidth, DWORD dwHeight, DWORD dwFilter);

#endif