/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2009 The LS-Universe Team

  Homepage: http://www.ls-universe.info

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#include "stdafx.h"
#include "SettingsHelpers.h"

#include "MultiMonitor.h"

extern MultiMonitor multimonitor;

//--------------------------------------------------------------------
//Defines for Vista
//--------------------------------------------------------------------
//COMMUNICATIONS
enum COMMUNICATIONSPARTS {
    CSST_TAB = 1,
};

enum TABSTATES {
    CSTB_NORMAL = 1,
    CSTB_HOT = 2,
    CSTB_SELECTED = 3,
};

//CONTROLPANEL
enum CONTROLPANELPARTS {
    CPANEL_NAVIGATIONPANE = 1,
    CPANEL_CONTENTPANE = 2,
    CPANEL_NAVIGATIONPANELABEL = 3,
    CPANEL_CONTENTPANELABEL = 4,
    CPANEL_TITLE = 5,
    CPANEL_BODYTEXT = 6,
    CPANEL_HELPLINK = 7,
    CPANEL_TASKLINK = 8,
    CPANEL_GROUPTEXT = 9,
    CPANEL_CONTENTLINK = 10,
    CPANEL_SECTIONTITLELINK = 11,
    CPANEL_LARGECOMMANDAREA = 12,
    CPANEL_SMALLCOMMANDAREA = 13,
    CPANEL_BUTTON = 14,
    CPANEL_MESSAGETEXT = 15,
    CPANEL_NAVIGATIONPANELINE = 16,
    CPANEL_CONTENTPANELINE = 17,
    CPANEL_BANNERAREA = 18,
    CPANEL_BODYTITLE = 19,
};

enum HELPLINKSTATES {
    CPHL_NORMAL = 1,
    CPHL_HOT = 2,
    CPHL_PRESSED = 3,
    CPHL_DISABLED = 4,
};

enum TASKLINKSTATES {
    CPTL_NORMAL = 1,
    CPTL_HOT = 2,
    CPTL_PRESSED = 3,
    CPTL_DISABLED = 4,
    CPTL_PAGE = 5,
};

enum CONTENTLINKSTATES {
    CPCL_NORMAL = 1,
    CPCL_HOT = 2,
    CPCL_PRESSED = 3,
    CPCL_DISABLED = 4,
};

enum SECTIONTITLELINKSTATES {
    CPSTL_NORMAL = 1,
    CPSTL_HOT = 2,
};

//DATEPICKER
enum DATEPICKERPARTS {
    DP_DATETEXT = 1,
    DP_DATEBORDER = 2,
    DP_SHOWCALENDARBUTTONRIGHT = 3,
};

enum DATETEXTSTATES {
    DPDT_NORMAL = 1,
    DPDT_DISABLED = 2,
    DPDT_SELECTED = 3,
};

enum DATEBORDERSTATES {
    DPDB_NORMAL = 1,
    DPDB_HOT = 2,
    DPDB_FOCUSED = 3,
    DPDB_DISABLED = 4,
};

enum SHOWCALENDARBUTTONRIGHTSTATES {
    DPSCBR_NORMAL = 1,
    DPSCBR_HOT = 2,
    DPSCBR_PRESSED = 3,
    DPSCBR_DISABLED = 4,
};

//DRAGDROP
enum DRAGDROPPARTS {
    DD_COPY = 1,
    DD_MOVE = 2,
    DD_UPDATEMETADATA = 3,
    DD_CREATELINK = 4,
    DD_WARNING = 5,
    DD_NONE = 6,
    DD_IMAGEBG = 7,
    DD_TEXTBG = 8,
};

enum COPYSTATES {
    DDCOPY_HIGHLIGHT = 1,
    DDCOPY_NOHIGHLIGHT = 2,
};

enum MOVESTATES {
    DDMOVE_HIGHLIGHT = 1,
    DDMOVE_NOHIGHLIGHT = 2,
};

enum UPDATEMETADATASTATES {
    DDUPDATEMETADATA_HIGHLIGHT = 1,
    DDUPDATEMETADATA_NOHIGHLIGHT = 2,
};

enum CREATELINKSTATES {
    DDCREATELINK_HIGHLIGHT = 1,
    DDCREATELINK_NOHIGHLIGHT = 2,
};

enum WARNINGSTATES {
    DDWARNING_HIGHLIGHT = 1,
    DDWARNING_NOHIGHLIGHT = 2,
};

enum NONESTATES {
    DDNONE_HIGHLIGHT = 1,
    DDNONE_NOHIGHLIGHT = 2,
};

//FLYOUT
enum FLYOUTPARTS {
    FLYOUT_HEADER = 1,
    FLYOUT_BODY = 2,
    FLYOUT_LABEL = 3,
    FLYOUT_LINK = 4,
    FLYOUT_DIVIDER = 5,
    FLYOUT_WINDOW = 6,
    FLYOUT_LINKAREA = 7,
    FLYOUT_LINKHEADER = 8,
};

enum LABELSTATES {
    FLS_NORMAL = 1,
    FLS_SELECTED = 2,
    FLS_EMPHASIZED = 3,
    FLS_DISABLED = 4,
};

enum LINKSTATES {
    FLYOUTLINK_NORMAL = 1,
    FLYOUTLINK_HOVER = 2,
};

enum BODYSTATES {
    FBS_NORMAL = 1,
    FBS_EMPHASIZED = 2,
};

enum LINKHEADERSTATES {
    FLH_NORMAL = 1,
    FLH_HOVER = 2,
};

//LISTBOX
enum LISTBOXPARTS {
    LBCP_BORDER_HSCROLL = 1,
    LBCP_BORDER_HVSCROLL = 2,
    LBCP_BORDER_NOSCROLL = 3,
    LBCP_BORDER_VSCROLL = 4,
    LBCP_ITEM = 5,
};

enum BORDER_HSCROLLSTATES {
    LBPSH_NORMAL = 1,
    LBPSH_FOCUSED = 2,
    LBPSH_HOT = 3,
    LBPSH_DISABLED = 4,
};

enum BORDER_HVSCROLLSTATES {
    LBPSHV_NORMAL = 1,
    LBPSHV_FOCUSED = 2,
    LBPSHV_HOT = 3,
    LBPSHV_DISABLED = 4,
};

enum BORDER_NOSCROLLSTATES {
    LBPSN_NORMAL = 1,
    LBPSN_FOCUSED = 2,
    LBPSN_HOT = 3,
    LBPSN_DISABLED = 4,
};

enum BORDER_VSCROLLSTATES {
    LBPSV_NORMAL = 1,
    LBPSV_FOCUSED = 2,
    LBPSV_HOT = 3,
    LBPSV_DISABLED = 4,
};

enum ITEMSTATES {
    LBPSI_HOT = 1,
    LBPSI_HOTSELECTED = 2,
    LBPSI_SELECTED = 3,
    LBPSI_SELECTEDNOTFOCUS = 4,
};

//NAVIGATION
enum NAVIGATIONPARTS {
    NAV_BACKBUTTON = 1,
    NAV_FORWARDBUTTON = 2,
    NAV_MENUBUTTON = 3,
};

enum NAV_BACKBUTTONSTATES {
    NAV_BB_NORMAL = 1,
    NAV_BB_HOT = 2,
    NAV_BB_PRESSED = 3,
    NAV_BB_DISABLED = 4,
};

enum NAV_FORWARDBUTTONSTATES {
    NAV_FB_NORMAL = 1,
    NAV_FB_HOT = 2,
    NAV_FB_PRESSED = 3,
    NAV_FB_DISABLED = 4,
};

enum NAV_MENUBUTTONSTATES {
    NAV_MB_NORMAL = 1,
    NAV_MB_HOT = 2,
    NAV_MB_PRESSED = 3,
    NAV_MB_DISABLED = 4,
};

//REBAR
#define RP_BACKGROUND  6
#define RP_SPLITTER  7
#define RP_SPLITTERVERT  8

enum CHEVRONVERTSTATES {
    CHEVSV_NORMAL = 1,
    CHEVSV_HOT = 2,
    CHEVSV_PRESSED = 3,
};

enum SPLITTERSTATES {
    SPLITS_NORMAL = 1,
    SPLITS_HOT = 2,
    SPLITS_PRESSED = 3,
};

enum SPLITTERVERTSTATES {
    SPLITSV_NORMAL = 1,
    SPLITSV_HOT = 2,
    SPLITSV_PRESSED = 3,
};

//TASKSDIALOG
enum TASKDIALOGPARTS {
    TDLG_PRIMARYPANEL = 1,
    TDLG_MAININSTRUCTIONPANE = 2,
    TDLG_MAINICON = 3,
    TDLG_CONTENTPANE = 4,
    TDLG_CONTENTICON = 5,
    TDLG_EXPANDEDCONTENT = 6,
    TDLG_COMMANDLINKPANE = 7,
    TDLG_SECONDARYPANEL = 8,
    TDLG_CONTROLPANE = 9,
    TDLG_BUTTONSECTION = 10,
    TDLG_BUTTONWRAPPER = 11,
    TDLG_EXPANDOTEXT = 12,
    TDLG_EXPANDOBUTTON = 13,
    TDLG_VERIFICATIONTEXT = 14,
    TDLG_FOOTNOTEPANE = 15,
    TDLG_FOOTNOTEAREA = 16,
    TDLG_FOOTNOTESEPARATOR = 17,
    TDLG_EXPANDEDFOOTERAREA = 18,
    TDLG_PROGRESSBAR = 19,
    TDLG_IMAGEALIGNMENT = 20,
    TDLG_RADIOBUTTONPANE = 21,
};

enum CONTENTPANESTATES {
    TDLGCPS_STANDALONE = 1,
};

enum EXPANDOBUTTONSTATES {
    TDLGEBS_NORMAL = 1,
    TDLGEBS_HOVER = 2,
    TDLGEBS_PRESSED = 3,
    TDLGEBS_EXPANDEDNORMAL = 4,
    TDLGEBS_EXPANDEDHOVER = 5,
    TDLGEBS_EXPANDEDPRESSED = 6,
};

//TEXTSTYLE
enum TEXTSTYLEPARTS {
    TEXT_MAININSTRUCTION = 1,
    TEXT_INSTRUCTION = 2,
    TEXT_BODYTITLE = 3,
    TEXT_BODYTEXT = 4,
    TEXT_SECONDARYTEXT = 5,
    TEXT_HYPERLINKTEXT = 6,
    TEXT_EXPANDED = 7,
    TEXT_LABEL = 8,
    TEXT_CONTROLLABEL = 9,
};

enum HYPERLINKTEXTSTATES {
    TS_HYPERLINK_NORMAL = 1,
    TS_HYPERLINK_HOT = 2,
    TS_HYPERLINK_PRESSED = 3,
    TS_HYPERLINK_DISABLED = 4,
};

enum CONTROLLABELSTATES {
    TS_CONTROLLABEL_NORMAL = 1,
    TS_CONTROLLABEL_DISABLED = 2,
};
//--------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////
// DLL Internal
//////////////////////////////////////////////////////////////////////

wstring StringToWString(const string &s)
{
    wstring temp(s.length(),L' ');
    copy(s.begin(), s.end(), temp.begin());
    return temp;
}

void ProcessColor(const string &cfg, COLORREF &clrResult)
{
    string tmpColor = cfg;

    if ( strstr( tmpColor.c_str(), "#" ) != NULL )
    {
        while ( strstr( tmpColor.c_str(), "#" ) != NULL )
            tmpColor.replace(tmpColor.find("#"), 1, "", 0);
    }
    
    char szFirst[MAX_LINE_LENGTH] = {0};
    char szSecond[MAX_LINE_LENGTH] = {0};
    char szThird[MAX_LINE_LENGTH] = {0};

    LPSTR lpszTokens[3] = { szFirst, szSecond, szThird  };

    int nCount = LCTokenize(tmpColor.c_str(), lpszTokens, 3, NULL);

    if (nCount >= 3)
    {
        int nRed, nGreen, nBlue;

        nRed = strtol(szFirst, NULL, 10);
        nGreen = strtol(szSecond, NULL, 10);
        nBlue = strtol(szThird, NULL, 10);

        clrResult = RGB(nRed, nGreen, nBlue);
    }
    else if (nCount >= 1)
    {
        tmpColor = szFirst;

        if (tmpColor.length() == 3)
        {
            clrResult = strtol((tmpColor.substr(0,1) + tmpColor.substr(0,1) + tmpColor.substr(1,1) + tmpColor.substr(1,1) + tmpColor.substr(2,1) + tmpColor.substr(2,1)).c_str(), NULL, 16);
            // convert from BGR to RGB
            clrResult = RGB(GetBValue(clrResult), GetGValue(clrResult), GetRValue(clrResult));
        }
        else
        {
            clrResult = strtol(szFirst, NULL, 16);
            // convert from BGR to RGB
            clrResult = RGB(GetBValue(clrResult), GetGValue(clrResult), GetRValue(clrResult));
        }
    }
}

void ParseBGBevelColorCFG(const string &cfg, COLORREF &bgcolor, COLORREF &lightcolor, COLORREF &darkcolor)
{
    if ( cfg.empty() )
        return;

    CStr strProcessing = cfg.c_str();
    strProcessing.Replace("\"", "");

    char bg[32] = {0};
    char light[32] = {0};
    char dark[32] = {0};
    char *buffers[] = {bg, light, dark};

    int numTokens = LCTokenize(strProcessing, buffers, 3, NULL);

    if(numTokens == 1)
    {
        ProcessColor(bg, bgcolor);
        lightcolor = GetSysColor(COLOR_3DLIGHT);
        darkcolor = GetSysColor(COLOR_3DSHADOW);
    }
    else if (numTokens == 2)
    {
        ProcessColor(bg, bgcolor);
    
        ProcessColor(light, lightcolor);
        darkcolor = lightcolor;
    }
    else if (numTokens == 3)
    {
        ProcessColor(bg, bgcolor);

        ProcessColor(light, lightcolor);

        ProcessColor(dark, darkcolor);
    }
}

bool Parse4SizesCFG(const string &cfg, int &leftSize, int &rightSize, int &topSize, int &bottomSize, bool bOnlyPositiveValues)
{
    leftSize = 0;
    rightSize = 0;
    topSize = 0;
    bottomSize = 0;

    if ( cfg.empty() )
        return false;

    CStr strProcessing = cfg.c_str();
    strProcessing.Replace("\"", "");
    
    char left[32] = {0};
    char right[32] = {0};
    char top[32] = {0};
    char bottom[32] = {0};
    char *buffers[] = {left, right, top, bottom };

    int numTokens = LCTokenize(strProcessing, buffers, 4, NULL);
        
    if(numTokens == 1)
    {
        leftSize = rightSize = topSize = bottomSize = atoi(left);
    }
    else if (numTokens == 2)
    {
        leftSize = rightSize = atoi(left);
        topSize = bottomSize = atoi(right);
    }
    else if (numTokens == 4)
    {
        leftSize = atoi(left);
        rightSize = atoi(right);
        topSize = atoi(top);
        bottomSize = atoi(bottom);
    }

    if (bOnlyPositiveValues)
    {
        if ( leftSize <= 0 )
            leftSize = 0;

        if ( rightSize <= 0 )
            rightSize = 0;

        if ( topSize <= 0 )
            topSize = 0;

        if ( bottomSize <= 0 )
            bottomSize = 0;

        if ( leftSize > 0 || rightSize > 0 || topSize > 0 || bottomSize > 0 )
            return true;
        else
            return false;
    }
    else
    {
        if ( leftSize > 0 || rightSize > 0 || topSize > 0 || bottomSize > 0 )
            return true;
        else
            return false;
    }
}

void ParseRotationCFG(const string &cfg, int &degree, int &width, int &height)
{
    degree = 0;
    width = -1;
    height = -1;

    if ( cfg.empty() )
        return;

    CStr strProcessing = cfg.c_str();
    strProcessing.Replace("\"", "");
    
    char d[32] = {0};
    char w[32] = {0};
    char h[32] = {0};
    char *buffers[] = {d, w, h};

    int numTokens = LCTokenize(strProcessing, buffers, 3, NULL);
        
    if (numTokens == 1)
    {
        degree = atoi(d);
    }
    else if (numTokens == 3)
    {
        degree = atoi(d);
        width = atoi(w);
        height = atoi(h);
    }

    if ( degree <= -360 || degree >= 360 )
        degree = 0;

    if ( width <= 0 )
        width = -1;
    if ( height <= 0 )
        height = -1;
}

void ParseStyleCFG(const string &cfg, wstring &strClass, int &iPart, int &iState)
{
    strClass = L"";
    iPart = 0;
    iState = 0;

    if ( cfg.empty() )
        return;

    CStr strProcessing = cfg.c_str();
    strProcessing.Replace("\"", "");
    
    char c[256] = {0};
    char p[64] = {0};
    char s[64] = {0};
    char *buffers[] = {c, p, s};

    string strTmpClass = "";
    string strTmpPart = "";
    string strTmpState = "";

    int numTokens = LCTokenize(strProcessing, buffers, 3, NULL);
        
    if (numTokens >= 1)
    {
        strTmpClass = c;
    }
    if (numTokens >= 2)
    {
        strTmpPart = p;
    }
    if (numTokens == 3)
    {
        strTmpState = s;
    }

    //PostProcessing Style Class
    /*int slength = (int) strTmpClass.length() + 1;
    int len = MultiByteToWideChar(CP_ACP, 0, strTmpClass.c_str(), slength, 0, 0);
    wchar_t* buf = new wchar_t[len];
    MultiByteToWideChar(CP_ACP, 0, strTmpClass.c_str(), slength, buf, len);
    strClass = buf;
    delete[] buf;*/
    strClass = StringToWString(strTmpClass);

    const NameValuePair partConstants[] =
    {
        { "WP_CAPTION", WP_CAPTION },
        { "WP_SMALLCAPTION", WP_SMALLCAPTION },
        { "WP_MINCAPTION", WP_MINCAPTION },
        { "WP_SMALLMINCAPTION", WP_SMALLMINCAPTION },
        { "WP_MAXCAPTION", WP_MAXCAPTION },
        { "WP_SMALLMAXCAPTION", WP_SMALLMAXCAPTION },
        { "WP_FRAMELEFT", WP_FRAMELEFT },
        { "WP_FRAMERIGHT", WP_FRAMERIGHT },
        { "WP_FRAMEBOTTOM", WP_FRAMEBOTTOM },
        { "WP_SMALLFRAMELEFT", WP_SMALLFRAMELEFT },
        { "WP_SMALLFRAMERIGHT", WP_SMALLFRAMERIGHT },
        { "WP_SMALLFRAMEBOTTOM", WP_SMALLFRAMEBOTTOM },

        { "WP_SYSBUTTON", WP_SYSBUTTON },
        { "WP_MDISYSBUTTON", WP_MDISYSBUTTON },
        { "WP_MINBUTTON", WP_MINBUTTON },
        { "WP_MDIMINBUTTON", WP_MDIMINBUTTON },
        { "WP_MAXBUTTON", WP_MAXBUTTON },
        { "WP_CLOSEBUTTON", WP_CLOSEBUTTON },
        { "WP_SMALLCLOSEBUTTON", WP_SMALLCLOSEBUTTON },
        { "WP_MDICLOSEBUTTON", WP_MDICLOSEBUTTON },
        { "WP_RESTOREBUTTON", WP_RESTOREBUTTON },
        { "WP_MDIRESTOREBUTTON", WP_MDIRESTOREBUTTON },
        { "WP_HELPBUTTON", WP_HELPBUTTON },
        { "WP_MDIHELPBUTTON", WP_MDIHELPBUTTON },

        { "WP_HORZSCROLL", WP_HORZSCROLL },
        { "WP_HORZTHUMB", WP_HORZTHUMB },
        { "WP_VERTSCROLL", WP_VERTSCROLL },
        { "WP_VERTTHUMB", WP_VERTTHUMB },

        { "WP_DIALOG", WP_DIALOG },

        { "WP_CAPTIONSIZINGTEMPLATE", WP_CAPTIONSIZINGTEMPLATE },
        { "WP_SMALLCAPTIONSIZINGTEMPLATE", WP_SMALLCAPTIONSIZINGTEMPLATE },
        { "WP_FRAMELEFTSIZINGTEMPLATE", WP_FRAMELEFTSIZINGTEMPLATE },
        { "WP_SMALLFRAMELEFTSIZINGTEMPLATE", WP_SMALLFRAMELEFTSIZINGTEMPLATE },
        { "WP_FRAMERIGHTSIZINGTEMPLATE", WP_FRAMERIGHTSIZINGTEMPLATE },
        { "WP_SMALLFRAMERIGHTSIZINGTEMPLATE", WP_SMALLFRAMERIGHTSIZINGTEMPLATE },
        { "WP_FRAMEBOTTOMSIZINGTEMPLATE", WP_FRAMEBOTTOMSIZINGTEMPLATE },
        { "WP_SMALLFRAMEBOTTOMSIZINGTEMPLATE", WP_SMALLFRAMEBOTTOMSIZINGTEMPLATE },

        { "BP_PUSHBUTTON", BP_PUSHBUTTON },
        { "BP_RADIOBUTTON", BP_RADIOBUTTON },
        { "BP_CHECKBOX", BP_CHECKBOX },
        { "BP_GROUPBOX", BP_GROUPBOX },
        { "BP_USERBUTTON", BP_USERBUTTON },

        { "RP_GRIPPER", RP_GRIPPER },
        { "RP_GRIPPERVERT", RP_GRIPPERVERT },
        { "RP_BAND", RP_BAND },
        { "RP_CHEVRON", RP_CHEVRON },
        { "RP_CHEVRONVERT", RP_CHEVRONVERT },

        { "TP_BUTTON", TP_BUTTON },
        { "TP_DROPDOWNBUTTON", TP_DROPDOWNBUTTON },
        { "TP_SPLITBUTTON", TP_SPLITBUTTON },
        { "TP_SPLITBUTTONDROPDOWN", TP_SPLITBUTTONDROPDOWN },
        { "TP_SEPARATOR", TP_SEPARATOR },
        { "TP_SEPARATORVERT", TP_SEPARATORVERT },

        { "SP_PANE", SP_PANE },
        { "SP_GRIPPERPANE", SP_GRIPPERPANE },
        { "SP_GRIPPER", SP_GRIPPER },

        { "MP_MENUITEM", MP_MENUITEM },
        { "MP_MENUDROPDOWN", MP_MENUDROPDOWN },
        { "MP_MENUBARITEM", MP_MENUBARITEM },
        { "MP_MENUBARDROPDOWN", MP_MENUBARDROPDOWN },
        { "MP_CHEVRON", MP_CHEVRON },
        { "MP_SEPARATOR", MP_SEPARATOR },

        { "LVP_LISTITEM", LVP_LISTITEM },
        { "LVP_LISTGROUP", LVP_LISTGROUP },
        { "LVP_LISTDETAIL", LVP_LISTDETAIL },
        { "LVP_LISTSORTEDDETAIL", LVP_LISTSORTEDDETAIL },
        { "LVP_EMPTYTEXT", LVP_EMPTYTEXT },

        { "HP_HEADERITEM", HP_HEADERITEM },
        { "HP_HEADERITEMLEFT", HP_HEADERITEMLEFT },
        { "HP_HEADERITEMRIGHT", HP_HEADERITEMRIGHT },
        { "HP_HEADERSORTARROW", HP_HEADERSORTARROW },

        { "PP_BAR", PP_BAR },
        { "PP_BARVERT", PP_BARVERT },
        { "PP_CHUNK", PP_CHUNK },
        { "PP_CHUNKVERT", PP_CHUNKVERT },

        { "TABP_TABITEM", TABP_TABITEM },
        { "TABP_TABITEMLEFTEDGE", TABP_TABITEMLEFTEDGE },
        { "TABP_TABITEMRIGHTEDGE", TABP_TABITEMRIGHTEDGE },
        { "TABP_TABITEMBOTHEDGE", TABP_TABITEMBOTHEDGE },
        { "TABP_TOPTABITEM", TABP_TOPTABITEM },
        { "TABP_TOPTABITEMLEFTEDGE", TABP_TOPTABITEMLEFTEDGE },
        { "TABP_TOPTABITEMRIGHTEDGE", TABP_TOPTABITEMRIGHTEDGE },
        { "TABP_TOPTABITEMBOTHEDGE", TABP_TOPTABITEMBOTHEDGE },
        { "TABP_PANE", TABP_PANE },
        { "TABP_BODY", TABP_BODY },

        { "TKP_TRACK", TKP_TRACK },
        { "TKP_TRACKVERT", TKP_TRACKVERT },
        { "TKP_THUMB", TKP_THUMB },
        { "TKP_THUMBBOTTOM", TKP_THUMBBOTTOM },
        { "TKP_THUMBTOP", TKP_THUMBTOP },
        { "TKP_THUMBVERT", TKP_THUMBVERT },
        { "TKP_THUMBLEFT", TKP_THUMBLEFT },
        { "TKP_THUMBRIGHT", TKP_THUMBRIGHT },
        { "TKP_TICS", TKP_TICS },
        { "TKP_TICSVERT", TKP_TICSVERT },

        { "TTP_STANDARD", TTP_STANDARD },
        { "TTP_STANDARDTITLE", TTP_STANDARDTITLE },
        { "TTP_BALLOON", TTP_BALLOON },
        { "TTP_BALLOONTITLE", TTP_BALLOONTITLE },
        { "TTP_CLOSE", TTP_CLOSE },

        { "TVP_TREEITEM", TVP_TREEITEM },
        { "TVP_GLYPH", TVP_GLYPH },
        { "TVP_BRANCH", TVP_BRANCH },

        { "SPNP_UP", SPNP_UP },
        { "SPNP_DOWN", SPNP_DOWN },
        { "SPNP_UPHORZ", SPNP_UPHORZ },
        { "SPNP_DOWNHORZ", SPNP_DOWNHORZ },

        { "PGRP_UP", PGRP_UP },
        { "PGRP_DOWN", PGRP_DOWN },
        { "PGRP_UPHORZ", PGRP_UPHORZ },
        { "PGRP_DOWNHORZ", PGRP_DOWNHORZ },

        { "SBP_ARROWBTN", SBP_ARROWBTN },
        { "SBP_THUMBBTNHORZ", SBP_THUMBBTNHORZ },
        { "SBP_THUMBBTNVERT", SBP_THUMBBTNVERT },
        { "SBP_LOWERTRACKHORZ", SBP_LOWERTRACKHORZ },
        { "SBP_UPPERTRACKHORZ", SBP_UPPERTRACKHORZ },
        { "SBP_LOWERTRACKVERT", SBP_LOWERTRACKVERT },
        { "SBP_UPPERTRACKVERT", SBP_UPPERTRACKVERT },
        { "SBP_GRIPPERHORZ", SBP_GRIPPERHORZ },
        { "SBP_GRIPPERVERT", SBP_GRIPPERVERT },
        { "SBP_SIZEBOX", SBP_SIZEBOX },

        { "EP_EDITTEXT", EP_EDITTEXT },
        { "EP_CARET", EP_CARET },

        { "CP_DROPDOWNBUTTON", CP_DROPDOWNBUTTON },
 
        { "CLP_TIME", CLP_TIME },

        { "TNP_BACKGROUND", TNP_BACKGROUND },
        { "TNP_ANIMBACKGROUND", TNP_ANIMBACKGROUND },

        { "TBP_BACKGROUNDBOTTOM", TBP_BACKGROUNDBOTTOM },
        { "TBP_BACKGROUNDRIGHT", TBP_BACKGROUNDRIGHT },
        { "TBP_BACKGROUNDTOP", TBP_BACKGROUNDTOP },
        { "TBP_BACKGROUNDLEFT", TBP_BACKGROUNDLEFT },
        { "TBP_SIZINGBARBOTTOM", TBP_SIZINGBARBOTTOM },
        { "TBP_SIZINGBARRIGHT", TBP_SIZINGBARRIGHT },
        { "TBP_SIZINGBARTOP", TBP_SIZINGBARTOP },
        { "TBP_SIZINGBARLEFT", TBP_SIZINGBARLEFT },

        { "TDP_GROUPCOUNT", TDP_GROUPCOUNT },
        { "TDP_FLASHBUTTON", TDP_FLASHBUTTON },
        { "TDP_FLASHBUTTONGROUPMENU", TDP_FLASHBUTTONGROUPMENU },

        { "SPP_USERPANE", SPP_USERPANE },
        { "SPP_MOREPROGRAMS", SPP_MOREPROGRAMS },
        { "SPP_MOREPROGRAMSARROW", SPP_MOREPROGRAMSARROW },
        { "SPP_PROGLIST", SPP_PROGLIST },
        { "SPP_PROGLISTSEPARATOR", SPP_PROGLISTSEPARATOR },
        { "SPP_PLACESLIST", SPP_PLACESLIST },
        { "SPP_PLACESLISTSEPARATOR", SPP_PLACESLISTSEPARATOR },
        { "SPP_LOGOFF", SPP_LOGOFF },
        { "SPP_LOGOFFBUTTONS", SPP_LOGOFFBUTTONS },
        { "SPP_USERPICTURE", SPP_USERPICTURE },
        { "SPP_PREVIEW", SPP_PREVIEW },

        { "EBP_HEADERBACKGROUND", EBP_HEADERBACKGROUND },
        { "EBP_HEADERCLOSE", EBP_HEADERCLOSE },
        { "EBP_HEADERPIN", EBP_HEADERPIN },
        { "EBP_IEBARMENU", EBP_IEBARMENU },
        { "EBP_NORMALGROUPBACKGROUND", EBP_NORMALGROUPBACKGROUND },
        { "EBP_NORMALGROUPCOLLAPSE", EBP_NORMALGROUPCOLLAPSE },
        { "EBP_NORMALGROUPEXPAND", EBP_NORMALGROUPEXPAND },
        { "EBP_NORMALGROUPHEAD", EBP_NORMALGROUPHEAD },
        { "EBP_SPECIALGROUPBACKGROUND", EBP_SPECIALGROUPBACKGROUND },
        { "EBP_SPECIALGROUPCOLLAPSE", EBP_SPECIALGROUPCOLLAPSE },
        { "EBP_SPECIALGROUPEXPAND", EBP_SPECIALGROUPEXPAND },
        { "EBP_SPECIALGROUPHEAD", EBP_SPECIALGROUPHEAD },

        { "MDP_NEWAPPBUTTON", MDP_NEWAPPBUTTON },
        { "MDP_SEPERATOR", MDP_SEPERATOR },

        //Vista
        { "CSST_TAB", CSST_TAB },

        { "CPANEL_NAVIGATIONPANE", CPANEL_NAVIGATIONPANE },
        { "CPANEL_CONTENTPANE", CPANEL_CONTENTPANE },
        { "CPANEL_NAVIGATIONPANELABEL", CPANEL_NAVIGATIONPANELABEL },
        { "CPANEL_CONTENTPANELABEL", CPANEL_CONTENTPANELABEL },
        { "CPANEL_TITLE", CPANEL_TITLE },
        { "CPANEL_BODYTEXT", CPANEL_BODYTEXT },
        { "CPANEL_HELPLINK", CPANEL_HELPLINK },
        { "CPANEL_TASKLINK", CPANEL_TASKLINK },
        { "CPANEL_GROUPTEXT", CPANEL_GROUPTEXT },
        { "CPANEL_CONTENTLINK", CPANEL_CONTENTLINK },
        { "CPANEL_SECTIONTITLELINK", CPANEL_SECTIONTITLELINK },
        { "CPANEL_LARGECOMMANDAREA", CPANEL_LARGECOMMANDAREA },
        { "CPANEL_SMALLCOMMANDAREA", CPANEL_SMALLCOMMANDAREA },
        { "CPANEL_BUTTON", CPANEL_BUTTON },
        { "CPANEL_MESSAGETEXT", CPANEL_MESSAGETEXT },
        { "CPANEL_NAVIGATIONPANELINE", CPANEL_NAVIGATIONPANELINE },
        { "CPANEL_CONTENTPANELINE", CPANEL_CONTENTPANELINE },
        { "CPANEL_BANNERAREA", CPANEL_BANNERAREA },
        { "CPANEL_BODYTITLE", CPANEL_BODYTITLE },

        { "DP_DATETEXT", DP_DATETEXT },
        { "DP_DATEBORDER", DP_DATEBORDER },
        { "DP_SHOWCALENDARBUTTONRIGHT", DP_SHOWCALENDARBUTTONRIGHT },

        { "DD_COPY", DD_COPY },
        { "DD_MOVE", DD_MOVE },
        { "DD_UPDATEMETADATA", DD_UPDATEMETADATA },
        { "DD_CREATELINK", DD_CREATELINK },
        { "DD_WARNING", DD_WARNING },
        { "DD_NONE", DD_NONE },
        { "DD_IMAGEBG", DD_IMAGEBG },
        { "DD_TEXTBG", DD_TEXTBG },

        { "FLYOUT_HEADER", FLYOUT_HEADER },
        { "FLYOUT_BODY", FLYOUT_BODY },
        { "FLYOUT_LABEL", FLYOUT_LABEL },
        { "FLYOUT_LINK", FLYOUT_LINK },
        { "FLYOUT_DIVIDER", FLYOUT_DIVIDER },
        { "FLYOUT_WINDOW", FLYOUT_WINDOW },
        { "FLYOUT_LINKAREA", FLYOUT_LINKAREA },
        { "FLYOUT_LINKHEADER", FLYOUT_LINKHEADER },

        { "LBCP_BORDER_HSCROLL", LBCP_BORDER_HSCROLL },
        { "LBCP_BORDER_HVSCROLL", LBCP_BORDER_HVSCROLL },
        { "LBCP_BORDER_NOSCROLL", LBCP_BORDER_NOSCROLL },
        { "LBCP_BORDER_VSCROLL", LBCP_BORDER_VSCROLL },
        { "LBCP_ITEM", LBCP_ITEM },

        { "NAV_BACKBUTTON", NAV_BACKBUTTON },
        { "NAV_FORWARDBUTTON", NAV_FORWARDBUTTON },
        { "NAV_MENUBUTTON", NAV_MENUBUTTON },
    
        { "RP_GRIPPER", RP_GRIPPER },
        { "RP_GRIPPERVERT", RP_GRIPPERVERT },
        { "RP_BAND", RP_BAND },
        { "RP_CHEVRON", RP_CHEVRON },
        { "RP_CHEVRONVERT", RP_CHEVRONVERT },
        { "RP_BACKGROUND", RP_BACKGROUND },
        { "RP_SPLITTER", RP_SPLITTER },
        { "RP_SPLITTERVERT", RP_SPLITTERVERT },

        { "TDLG_PRIMARYPANEL", TDLG_PRIMARYPANEL },
        { "TDLG_MAININSTRUCTIONPANE", TDLG_MAININSTRUCTIONPANE },
        { "TDLG_MAINICON", TDLG_MAINICON },
        { "TDLG_CONTENTPANE", TDLG_CONTENTPANE },
        { "TDLG_CONTENTICON", TDLG_CONTENTICON },
        { "TDLG_EXPANDEDCONTENT", TDLG_EXPANDEDCONTENT },
        { "TDLG_COMMANDLINKPANE", TDLG_COMMANDLINKPANE },
        { "TDLG_SECONDARYPANEL", TDLG_SECONDARYPANEL },
        { "TDLG_CONTROLPANE", TDLG_CONTROLPANE },
        { "TDLG_BUTTONSECTION", TDLG_BUTTONSECTION },
        { "TDLG_BUTTONWRAPPER", TDLG_BUTTONWRAPPER },
        { "TDLG_EXPANDOTEXT", TDLG_EXPANDOTEXT },
        { "TDLG_EXPANDOBUTTON", TDLG_EXPANDOBUTTON },
        { "TDLG_VERIFICATIONTEXT", TDLG_VERIFICATIONTEXT },
        { "TDLG_FOOTNOTEPANE", TDLG_FOOTNOTEPANE },
        { "TDLG_FOOTNOTEAREA", TDLG_FOOTNOTEAREA },
        { "TDLG_FOOTNOTESEPARATOR", TDLG_FOOTNOTESEPARATOR },
        { "TDLG_EXPANDEDFOOTERAREA", TDLG_EXPANDEDFOOTERAREA },
        { "TDLG_PROGRESSBAR", TDLG_PROGRESSBAR },
        { "TDLG_IMAGEALIGNMENT", TDLG_IMAGEALIGNMENT },
        { "TDLG_RADIOBUTTONPANE", TDLG_RADIOBUTTONPANE },

        { "TEXT_MAININSTRUCTION", TEXT_MAININSTRUCTION },
        { "TEXT_INSTRUCTION", TEXT_INSTRUCTION },
        { "TEXT_BODYTITLE", TEXT_BODYTITLE },
        { "TEXT_BODYTEXT", TEXT_BODYTEXT },
        { "TEXT_SECONDARYTEXT", TEXT_SECONDARYTEXT },
        { "TEXT_HYPERLINKTEXT", TEXT_HYPERLINKTEXT },
        { "TEXT_EXPANDED", TEXT_EXPANDED },
        { "TEXT_LABEL", TEXT_LABEL },
        { "TEXT_CONTROLLABEL", TEXT_CONTROLLABEL },
        
        { 0, 0 }
    };

    const NameValuePair stateConstants[] =
    {
        { "FS_ACTIVE", FS_ACTIVE },
        { "FS_INACTIVE", FS_INACTIVE },

        { "CS_ACTIVE", CS_ACTIVE },
        { "CS_INACTIVE", CS_INACTIVE },
        { "CS_DISABLED", CS_DISABLED },

        { "MXCS_ACTIVE", MXCS_ACTIVE },
        { "MXCS_INACTIVE", MXCS_INACTIVE },
        { "MXCS_DISABLED", MXCS_DISABLED },

        { "MNCS_ACTIVE", MNCS_ACTIVE },
        { "MNCS_INACTIVE", MNCS_INACTIVE },
        { "MNCS_DISABLED", MNCS_DISABLED },

        { "HSS_NORMAL", HSS_NORMAL },
        { "HSS_HOT", HSS_HOT },
        { "HSS_PUSHED", HSS_PUSHED },
        { "HSS_DISABLED", HSS_DISABLED },

        { "HTS_NORMAL", HTS_NORMAL },
        { "HTS_HOT", HTS_HOT },
        { "HTS_PUSHED", HTS_PUSHED },
        { "HTS_DISABLED", HTS_DISABLED },

        { "VSS_NORMAL", VSS_NORMAL },
        { "VSS_HOT", VSS_HOT },
        { "VSS_PUSHED", VSS_PUSHED },
        { "VSS_DISABLED", VSS_DISABLED },

        { "VTS_NORMAL", VTS_NORMAL },
        { "VTS_HOT", VTS_HOT },
        { "VTS_PUSHED", VTS_PUSHED },
        { "VTS_DISABLED", VTS_DISABLED },

        { "SBS_NORMAL", SBS_NORMAL },
        { "SBS_HOT", SBS_HOT },
        { "SBS_PUSHED", SBS_PUSHED },
        { "SBS_DISABLED", SBS_DISABLED },

        { "MINBS_NORMAL", MINBS_NORMAL },
        { "MINBS_HOT", MINBS_HOT },
        { "MINBS_PUSHED", MINBS_PUSHED },
        { "MINBS_DISABLED", MINBS_DISABLED },

        { "MAXBS_NORMAL", MAXBS_NORMAL },
        { "MAXBS_HOT", MAXBS_HOT },
        { "MAXBS_PUSHED", MAXBS_PUSHED },
        { "MAXBS_DISABLED", MAXBS_DISABLED },

        { "RBS_NORMAL", RBS_NORMAL },
        { "RBS_HOT", RBS_HOT },
        { "RBS_PUSHED", RBS_PUSHED },
        { "RBS_DISABLED", RBS_DISABLED },

        { "HBS_NORMAL", HBS_NORMAL },
        { "HBS_HOT", HBS_HOT },
        { "HBS_PUSHED", HBS_PUSHED },
        { "HBS_DISABLED", HBS_DISABLED },

        { "CBS_NORMAL", CBS_NORMAL },
        { "CBS_HOT", CBS_HOT },
        { "CBS_PUSHED", CBS_PUSHED },
        { "CBS_DISABLED", CBS_DISABLED },

        { "PBS_NORMAL", PBS_NORMAL },
        { "PBS_HOT", PBS_HOT },
        { "PBS_PRESSED", PBS_PRESSED },
        { "PBS_DISABLED", PBS_DISABLED },
        { "PBS_DEFAULTED", PBS_DEFAULTED },

        { "RBS_UNCHECKEDNORMAL", RBS_UNCHECKEDNORMAL },
        { "RBS_UNCHECKEDHOT", RBS_UNCHECKEDHOT },
        { "RBS_UNCHECKEDPRESSED", RBS_UNCHECKEDPRESSED },
        { "RBS_UNCHECKEDDISABLED", RBS_UNCHECKEDDISABLED },
        { "RBS_CHECKEDNORMAL", RBS_CHECKEDNORMAL },
        { "RBS_CHECKEDHOT", RBS_CHECKEDHOT },
        { "RBS_CHECKEDPRESSED", RBS_CHECKEDPRESSED },
        { "RBS_CHECKEDDISABLED", RBS_CHECKEDDISABLED },

        { "CBS_UNCHECKEDNORMAL", CBS_UNCHECKEDNORMAL },
        { "CBS_UNCHECKEDHOT", CBS_UNCHECKEDHOT },
        { "CBS_UNCHECKEDPRESSED", CBS_UNCHECKEDPRESSED },
        { "CBS_UNCHECKEDDISABLED", CBS_UNCHECKEDDISABLED },
        { "CBS_CHECKEDNORMAL", CBS_CHECKEDNORMAL },
        { "CBS_CHECKEDHOT", CBS_CHECKEDHOT },
        { "CBS_CHECKEDPRESSED", CBS_CHECKEDPRESSED },
        { "CBS_CHECKEDDISABLED", CBS_CHECKEDDISABLED },
        { "CBS_MIXEDNORMAL", CBS_MIXEDNORMAL },
        { "CBS_MIXEDHOT", CBS_MIXEDHOT },
        { "CBS_MIXEDPRESSED", CBS_MIXEDPRESSED },
        { "CBS_MIXEDDISABLED", CBS_MIXEDDISABLED },

        { "GBS_NORMAL", GBS_NORMAL },
        { "GBS_DISABLED", GBS_DISABLED },

        { "CHEVS_NORMAL", CHEVS_NORMAL },
        { "CHEVS_HOT", CHEVS_HOT },
        { "CHEVS_PRESSED", CHEVS_PRESSED },

        { "TS_NORMAL", TS_NORMAL },
        { "TS_HOT", TS_HOT },
        { "TS_PRESSED", TS_PRESSED },
        { "TS_DISABLED", TS_DISABLED },
        { "TS_CHECKED", TS_CHECKED },
        { "TS_HOTCHECKED", TS_HOTCHECKED },

        { "MS_NORMAL", MS_NORMAL },
        { "MS_SELECTED", MS_SELECTED },
        { "MS_DEMOTED", MS_DEMOTED },

        { "LIS_NORMAL", LIS_NORMAL },
        { "LIS_HOT", LIS_HOT },
        { "LIS_SELECTED", LIS_SELECTED },
        { "LIS_DISABLED", LIS_DISABLED },
        { "LIS_SELECTEDNOTFOCUS", LIS_SELECTEDNOTFOCUS },

        { "HIS_NORMAL", HIS_NORMAL },
        { "HIS_HOT", HIS_HOT },
        { "HIS_PRESSED", HIS_PRESSED },

        { "HILS_NORMAL", HILS_NORMAL },
        { "HILS_HOT", HILS_HOT },
        { "HILS_PRESSED", HILS_PRESSED },

        { "HIRS_NORMAL", HIRS_NORMAL },
        { "HIRS_HOT", HIRS_HOT },
        { "HIRS_PRESSED", HIRS_PRESSED },

        { "HSAS_SORTEDUP", HSAS_SORTEDUP },
        { "HSAS_SORTEDDOWN", HSAS_SORTEDDOWN },

        { "TIS_NORMAL", TIS_NORMAL },
        { "TIS_HOT", TIS_HOT },
        { "TIS_SELECTED", TIS_SELECTED },
        { "TIS_DISABLED", TIS_DISABLED },
        { "TIS_FOCUSED", TIS_FOCUSED },

        { "TILES_NORMAL", TILES_NORMAL },
        { "TILES_HOT", TILES_HOT },
        { "TILES_SELECTED", TILES_SELECTED },
        { "TILES_DISABLED", TILES_DISABLED },
        { "TILES_FOCUSED", TILES_FOCUSED },

        { "TIRES_NORMAL", TIRES_NORMAL },
        { "TIRES_HOT", TIRES_HOT },
        { "TIRES_SELECTED", TIRES_SELECTED },
        { "TIRES_DISABLED", TIRES_DISABLED },
        { "TIRES_FOCUSED", TIRES_FOCUSED },

        { "TIBES_NORMAL", TIBES_NORMAL },
        { "TIBES_HOT", TIBES_HOT },
        { "TIBES_SELECTED", TIBES_SELECTED },
        { "TIBES_DISABLED", TIBES_DISABLED },
        { "TIBES_FOCUSED", TIBES_FOCUSED },

        { "TTIS_NORMAL", TTIS_NORMAL },
        { "TTIS_HOT", TTIS_HOT },
        { "TTIS_SELECTED", TTIS_SELECTED },
        { "TTIS_DISABLED", TTIS_DISABLED },
        { "TTIS_FOCUSED5", TTIS_FOCUSED },

        { "TTILES_NORMAL", TTILES_NORMAL },
        { "TTILES_HOT", TTILES_HOT },
        { "TTILES_SELECTED", TTILES_SELECTED },
        { "TTILES_DISABLED", TTILES_DISABLED },
        { "TTILES_FOCUSED", TTILES_FOCUSED },

        { "TTIRES_NORMAL", TTIRES_NORMAL },
        { "TTIRES_HOT", TTIRES_HOT },
        { "TTIRES_SELECTED", TTIRES_SELECTED },
        { "TTIRES_DISABLED", TTIRES_DISABLED },
        { "TTIRES_FOCUSED", TTIRES_FOCUSED },

        { "TTIBES_NORMAL", TTIBES_NORMAL },
        { "TTIBES_HOT", TTIBES_HOT },
        { "TTIBES_SELECTED", TTIBES_SELECTED },
        { "TTIBES_DISABLED", TTIBES_DISABLED },
        { "TTIBES_FOCUSED", TTIBES_FOCUSED },

        { "TKS_NORMAL", TKS_NORMAL },

        { "TRS_NORMAL", TRS_NORMAL },

        { "TRVS_NORMAL", TRVS_NORMAL },

        { "TUS_NORMAL", TUS_NORMAL },
        { "TUS_HOT", TUS_HOT },
        { "TUS_PRESSED", TUS_PRESSED },
        { "TUS_FOCUSED", TUS_FOCUSED },
        { "TUS_DISABLED", TUS_DISABLED },

        { "TUBS_NORMAL", TUBS_NORMAL },
        { "TUBS_HOT", TUBS_HOT },
        { "TUBS_PRESSED", TUBS_PRESSED },
        { "TUBS_FOCUSED", TUBS_FOCUSED },
        { "TUBS_DISABLED", TUBS_DISABLED },

        { "TUTS_NORMAL", TUTS_NORMAL },
        { "TUTS_HOT", TUTS_HOT },
        { "TUTS_PRESSED", TUTS_PRESSED },
        { "TUTS_FOCUSED", TUTS_FOCUSED },
        { "TUTS_DISABLED", TUTS_DISABLED },

        { "TUVS_NORMAL", TUVS_NORMAL },
        { "TUVS_HOT", TUVS_HOT },
        { "TUVS_PRESSED", TUVS_PRESSED },
        { "TUVS_FOCUSED", TUVS_FOCUSED },
        { "TUVS_DISABLED", TUVS_DISABLED },

        { "TUVLS_NORMAL", TUVLS_NORMAL },
        { "TUVLS_HOT", TUVLS_HOT },
        { "TUVLS_PRESSED", TUVLS_PRESSED },
        { "TUVLS_FOCUSED", TUVLS_FOCUSED },
        { "TUVLS_DISABLED", TUVLS_DISABLED },

        { "TUVRS_NORMAL", TUVRS_NORMAL },
        { "TUVRS_HOT", TUVRS_HOT },
        { "TUVRS_PRESSED", TUVRS_PRESSED },
        { "TUVRS_FOCUSED", TUVRS_FOCUSED },
        { "TUVRS_DISABLED", TUVRS_DISABLED },

        { "TSS_NORMAL", TSS_NORMAL },

        { "TSVS_NORMAL", TSVS_NORMAL },

        { "TTCS_NORMAL", TTCS_NORMAL },
        { "TTCS_HOT", TTCS_HOT },
        { "TTCS_PRESSED", TTCS_PRESSED },

        { "TTSS_NORMAL", TTSS_NORMAL },
        { "TTSS_LINK", TTSS_LINK },

        { "TTBS_NORMAL", TTBS_NORMAL },
        { "TTBS_LINK", TTBS_LINK },

        { "TREIS_NORMAL", TREIS_NORMAL },
        { "TREIS_HOT", TREIS_HOT },
        { "TREIS_SELECTED", TREIS_SELECTED },
        { "TREIS_DISABLED", TREIS_DISABLED },
        { "TREIS_SELECTEDNOTFOCUS", TREIS_SELECTEDNOTFOCUS },

        { "GLPS_CLOSED", GLPS_CLOSED },
        { "GLPS_OPENED", GLPS_OPENED },

        { "UPS_NORMAL", UPS_NORMAL },
        { "UPS_HOT", UPS_HOT },
        { "UPS_PRESSED", UPS_PRESSED },
        { "UPS_DISABLED", UPS_DISABLED },

        { "DNS_NORMAL", DNS_NORMAL },
        { "DNS_HOT", DNS_HOT },
        { "DNS_PRESSED", DNS_PRESSED },
        { "DNS_DISABLED", DNS_DISABLED },

        { "UPHZS_NORMAL", UPHZS_NORMAL },
        { "UPHZS_HOT", UPHZS_HOT },
        { "UPHZS_PRESSED", UPHZS_PRESSED },
        { "UPHZS_DISABLED", UPHZS_DISABLED },

        { "DNHZS_NORMAL", DNHZS_NORMAL },
        { "DNHZS_HOT", DNHZS_HOT },
        { "DNHZS_PRESSED", DNHZS_PRESSED },
        { "DNHZS_DISABLED", DNHZS_DISABLED },

        { "ABS_UPNORMAL", ABS_UPNORMAL },
        { "ABS_UPHOT", ABS_UPHOT },
        { "ABS_UPPRESSED", ABS_UPPRESSED },
        { "ABS_UPDISABLED", ABS_UPDISABLED },
        { "ABS_DOWNNORMAL", ABS_DOWNNORMAL },
        { "ABS_DOWNHOT", ABS_DOWNHOT },
        { "ABS_DOWNPRESSED", ABS_DOWNPRESSED },
        { "ABS_DOWNDISABLED", ABS_DOWNDISABLED },
        { "ABS_LEFTNORMAL", ABS_LEFTNORMAL },
        { "ABS_LEFTHOT", ABS_LEFTHOT },
        { "ABS_LEFTPRESSED", ABS_LEFTPRESSED },
        { "ABS_LEFTDISABLED", ABS_LEFTDISABLED },
        { "ABS_RIGHTNORMAL", ABS_RIGHTNORMAL },
        { "ABS_RIGHTHOT", ABS_RIGHTHOT },
        { "ABS_RIGHTPRESSED", ABS_RIGHTPRESSED },
        { "ABS_RIGHTDISABLED", ABS_RIGHTDISABLED },

        { "SCRBS_NORMAL", SCRBS_NORMAL },
        { "SCRBS_HOT", SCRBS_HOT },
        { "SCRBS_PRESSED", SCRBS_PRESSED },
        { "SCRBS_DISABLED", SCRBS_DISABLED },

        { "SZB_RIGHTALIGN", SZB_RIGHTALIGN },
        { "SZB_LEFTALIGN", SZB_LEFTALIGN },

        { "ETS_NORMAL", ETS_NORMAL },
        { "ETS_HOT", ETS_HOT },
        { "ETS_SELECTED", ETS_SELECTED },
        { "ETS_DISABLED", ETS_DISABLED },
        { "ETS_FOCUSED", ETS_FOCUSED },
        { "ETS_READONLY", ETS_READONLY },
        { "ETS_ASSIST", ETS_ASSIST },

        { "CBXS_NORMAL", CBXS_NORMAL },
        { "CBXS_HOT", CBXS_HOT },
        { "CBXS_PRESSED", CBXS_PRESSED },
        { "CBXS_DISABLED", CBXS_DISABLED },

        { "CLS_NORMAL", CLS_NORMAL },

        { "SPS_NORMAL", SPS_NORMAL },
        { "SPS_HOT", SPS_HOT },
        { "SPS_PRESSED", SPS_PRESSED },

        { "SPLS_NORMAL", SPLS_NORMAL },
        { "SPLS_HOT", SPLS_HOT },
        { "SPLS_PRESSED", SPLS_PRESSED },

        { "EBHC_NORMAL", EBHC_NORMAL },
        { "EBHC_HOT", EBHC_HOT },
        { "EBHC_PRESSED", EBHC_PRESSED },

        { "EBHP_NORMAL", EBHP_NORMAL },
        { "EBHP_HOT", EBHP_HOT },
        { "EBHP_PRESSED", EBHP_PRESSED },
        { "EBHP_SELECTEDNORMAL", EBHP_SELECTEDNORMAL },
        { "EBHP_SELECTEDHOT", EBHP_SELECTEDHOT },
        { "EBHP_SELECTEDPRESSED", EBHP_SELECTEDPRESSED },

        { "EBM_NORMAL", EBM_NORMAL },
        { "EBM_HOT", EBM_HOT },
        { "EBM_PRESSED", EBM_PRESSED },

        { "EBNGC_NORMAL", EBNGC_NORMAL },
        { "EBNGC_HOT", EBNGC_HOT },
        { "EBNGC_PRESSED", EBNGC_PRESSED },

        { "EBNGE_NORMAL", EBNGE_NORMAL },
        { "EBNGE_HOT", EBNGE_HOT },
        { "EBNGE_PRESSED", EBNGE_PRESSED },

        { "EBSGC_NORMAL", EBSGC_NORMAL },
        { "EBSGC_HOT", EBSGC_HOT },
        { "EBSGC_PRESSED", EBSGC_PRESSED },

        { "EBSGE_NORMAL", EBSGE_NORMAL },
        { "EBSGE_HOT", EBSGE_HOT },
        { "EBSGE_PRESSED", EBSGE_PRESSED },

        { "MDS_NORMAL", MDS_NORMAL },
        { "MDS_HOT", MDS_HOT },
        { "MDS_PRESSED", MDS_PRESSED },
        { "MDS_DISABLED", MDS_DISABLED },
        { "MDS_CHECKED", MDS_CHECKED },
        { "MDS_HOTCHECKED", MDS_HOTCHECKED },

        //Vista
        { "CSTB_NORMAL", CSTB_NORMAL },
        { "CSTB_HOT", CSTB_HOT },
        { "CSTB_SELECTED", CSTB_SELECTED },

        { "CPHL_NORMAL", CPHL_NORMAL },
        { "CPHL_HOT", CPHL_HOT },
        { "CPHL_PRESSED", CPHL_PRESSED },
        { "CPHL_DISABLED", CPHL_DISABLED },

        { "CPTL_NORMAL", CPTL_NORMAL },
        { "CPTL_HOT", CPTL_HOT },
        { "CPTL_PRESSED", CPTL_PRESSED },
        { "CPTL_DISABLED", CPTL_DISABLED },
        { "CPTL_PAGE", CPTL_PAGE },

        { "CPCL_NORMAL", CPCL_NORMAL },
        { "CPCL_HOT", CPCL_HOT },
        { "CPCL_PRESSED", CPCL_PRESSED },
        { "CPCL_DISABLED", CPCL_DISABLED },

        { "CPSTL_NORMAL", CPSTL_NORMAL },
        { "CPSTL_HOT", CPSTL_HOT },

        { "DPDT_NORMAL", DPDT_NORMAL },
        { "DPDT_DISABLED", DPDT_DISABLED },
        { "DPDT_SELECTED", DPDT_SELECTED },

        { "DPDB_NORMAL", DPDB_NORMAL },
        { "DPDB_HOT", DPDB_HOT },
        { "DPDB_FOCUSED", DPDB_FOCUSED },
        { "DPDB_DISABLED", DPDB_DISABLED },
            
        { "DPSCBR_NORMAL", DPSCBR_NORMAL },
        { "DPSCBR_HOT", DPSCBR_HOT },
        { "DPSCBR_PRESSED", DPSCBR_PRESSED },
        { "DPSCBR_DISABLED", DPSCBR_DISABLED },

        { "DDCOPY_HIGHLIGHT", DDCOPY_HIGHLIGHT },
        { "DDCOPY_NOHIGHLIGHT", DDCOPY_NOHIGHLIGHT },

        { "DDMOVE_HIGHLIGHT", DDMOVE_HIGHLIGHT },
        { "DDMOVE_NOHIGHLIGHT", DDMOVE_NOHIGHLIGHT },

        { "DDUPDATEMETADATA_HIGHLIGHT", DDUPDATEMETADATA_HIGHLIGHT },
        { "DDUPDATEMETADATA_NOHIGHLIGHT", DDUPDATEMETADATA_NOHIGHLIGHT },

        { "DDCREATELINK_HIGHLIGHT", DDCREATELINK_HIGHLIGHT },
        { "DDCREATELINK_NOHIGHLIGHT", DDCREATELINK_NOHIGHLIGHT },

        { "DDWARNING_HIGHLIGHT", DDWARNING_HIGHLIGHT },
        { "DDWARNING_NOHIGHLIGHT", DDWARNING_NOHIGHLIGHT },

        { "DDNONE_HIGHLIGHT", DDNONE_HIGHLIGHT },
        { "DDNONE_NOHIGHLIGHT", DDNONE_NOHIGHLIGHT },

        { "FLS_NORMAL", FLS_NORMAL },
        { "FLS_SELECTED", FLS_SELECTED },
        { "FLS_EMPHASIZED", FLS_EMPHASIZED },
        { "FLS_DISABLED", FLS_DISABLED },

        { "FLYOUTLINK_NORMAL", FLYOUTLINK_NORMAL },
        { "FLYOUTLINK_HOVER", FLYOUTLINK_HOVER },

        { "FBS_NORMAL", FBS_NORMAL },
        { "FBS_EMPHASIZED", FBS_EMPHASIZED },

        { "FLH_NORMAL", FLH_NORMAL },
        { "FLH_HOVER", FLH_HOVER },
    
        { "LBPSH_NORMAL", LBPSH_NORMAL },
        { "LBPSH_FOCUSED", LBPSH_FOCUSED },
        { "LBPSH_HOT", LBPSH_HOT },
        { "LBPSH_DISABLED", LBPSH_DISABLED },

        { "LBPSHV_NORMAL", LBPSHV_NORMAL },
        { "LBPSHV_FOCUSED", LBPSHV_FOCUSED },
        { "LBPSHV_HOT", LBPSHV_HOT },
        { "LBPSHV_DISABLED", LBPSHV_DISABLED },
             
        { "LBPSN_NORMAL", LBPSN_NORMAL },
        { "LBPSN_FOCUSED", LBPSN_FOCUSED },
        { "LBPSN_HOT", LBPSN_HOT },
        { "LBPSN_DISABLED", LBPSN_DISABLED },

        { "LBPSV_NORMAL", LBPSV_NORMAL },
        { "LBPSV_FOCUSED", LBPSV_FOCUSED },
        { "LBPSV_HOT", LBPSV_HOT },
        { "LBPSV_DISABLED", LBPSV_DISABLED },
            
        { "LBPSI_HOT", LBPSI_HOT },
        { "LBPSI_HOTSELECTED", LBPSI_HOTSELECTED },
        { "LBPSI_SELECTED", LBPSI_SELECTED },
        { "LBPSI_SELECTEDNOTFOCUS", LBPSI_SELECTEDNOTFOCUS },

        { "NAV_BB_NORMAL", NAV_BB_NORMAL },
        { "NAV_BB_HOT", NAV_BB_HOT },
        { "NAV_BB_PRESSED", NAV_BB_PRESSED },
        { "NAV_BB_DISABLED", NAV_BB_DISABLED },

        { "NAV_FB_NORMAL", NAV_FB_NORMAL },
        { "NAV_FB_HOT", NAV_FB_HOT },
        { "NAV_FB_PRESSED", NAV_FB_PRESSED },
        { "NAV_FB_DISABLED", NAV_FB_DISABLED },
            
        { "NAV_MB_NORMAL", NAV_MB_NORMAL },
        { "NAV_MB_HOT", NAV_MB_HOT },
        { "NAV_MB_PRESSED", NAV_MB_PRESSED },
        { "NAV_MB_DISABLED", NAV_MB_DISABLED },
            
        { "CHEVS_NORMAL", CHEVS_NORMAL },
        { "CHEVS_HOT", CHEVS_HOT },
        { "CHEVS_PRESSED", CHEVS_PRESSED },

        { "CHEVSV_NORMAL", CHEVSV_NORMAL },
        { "CHEVSV_HOT", CHEVSV_HOT },
        { "CHEVSV_PRESSED", CHEVSV_PRESSED },

        { "SPLITS_NORMAL", SPLITS_NORMAL },
        { "SPLITS_HOT", SPLITS_HOT },
        { "SPLITS_PRESSED", SPLITS_PRESSED },

        { "SPLITSV_NORMAL", SPLITSV_NORMAL },
        { "SPLITSV_HOT", SPLITSV_HOT },
        { "SPLITSV_PRESSED", SPLITSV_PRESSED },

        { "TDLGCPS_STANDALONE", TDLGCPS_STANDALONE },

        { "TDLGEBS_NORMAL", TDLGEBS_NORMAL },
        { "TDLGEBS_HOVER", TDLGEBS_HOVER },
        { "TDLGEBS_PRESSED", TDLGEBS_PRESSED },
        { "TDLGEBS_EXPANDEDNORMAL", TDLGEBS_EXPANDEDNORMAL },
        { "TDLGEBS_EXPANDEDHOVER", TDLGEBS_EXPANDEDHOVER },
        { "TDLGEBS_EXPANDEDPRESSED", TDLGEBS_EXPANDEDPRESSED },

        { "TS_HYPERLINK_NORMAL", TS_HYPERLINK_NORMAL },
        { "TS_HYPERLINK_HOT", TS_HYPERLINK_HOT },
        { "TS_HYPERLINK_PRESSED", TS_HYPERLINK_PRESSED },
        { "TS_HYPERLINK_DISABLED", TS_HYPERLINK_DISABLED },

        { "TS_CONTROLLABEL_NORMAL", TS_CONTROLLABEL_NORMAL },
        { "TS_CONTROLLABEL_DISABLED", TS_CONTROLLABEL_DISABLED },

        { 0, 0 }
    };

    // Style Part
    const NameValuePair *current = partConstants;

    if(strTmpPart.length() > 0)
    {
        while(current->name)
        {
            if(_stricmp(current->name, strTmpPart.c_str()) == 0)
            {
                iPart = current->value;
                break;
            }

            current++;
        }
    }

    // Style State
    current = stateConstants;

    if(strTmpState.length() > 0)
    {
        while(current->name)
        {
            if(_stricmp(current->name, strTmpState.c_str()) == 0)
            {
                iState = current->value;
                break;
            }

            current++;
        }
    }

    if ( iPart == 0 && iState != 0 )
        iState = 0;
}

// trim leading and trailing whitespace
string trim(const string &toTrim)
{
    int start = 0;
    int end = toTrim.length() - 1;
    
    while(start <= end && isspace(toTrim[start]))
        start++;
    
    while(start <= end && isspace(toTrim[end]))
        end--;
    
    return toTrim.substr(start, end - start + 1);
}

string IntToString(int input)
{
    char buffer[32] = {0};
    _itoa( input, buffer, 10 );
    return (string) buffer;
}

// retrieve a boolean value from the step.rc
bool iGetxRCBool(const string &uniqueKey, const string &baseName, bool defaultVal)
{
    string key = uniqueKey + baseName;

    return (GetRCBoolDef(key.c_str(), defaultVal) ? true : false);
}

// retrieve a boolean value from the step.rc
bool iGetx2RCBool(const string &uniqueKey, const string &baseName, bool defaultVal)
{   
    string strTmpValue = iGetxRCString(uniqueKey, baseName, "");
    //Special Setup Due to FALSE set BOOL value
    if ( _stricmp(strTmpValue.c_str(), "false") == NULL || _stricmp(strTmpValue.c_str(), "off") == NULL || _stricmp(strTmpValue.c_str(), "no") == NULL )
        return false;
    else if ( iGetxRCBool(uniqueKey, baseName) )
        return true;

    string strGroups = iGetxRCLine(uniqueKey, "AddToGroup", "");
    string strNextGroup = "";

    if ( !strGroups.empty() )
    {
        char szBuffer[MAX_LINE_LENGTH] = {0};
        LPCSTR pszNextToken = strGroups.c_str();

        while ( GetToken(pszNextToken, szBuffer, &pszNextToken, false) )
        {
            if ( strNextGroup.empty() )
                strNextGroup = szBuffer;

            if ( iGetxRCBool(szBuffer, baseName) )
                return iGetxRCBool(szBuffer, baseName, defaultVal);
        }

        if ( _stricmp(uniqueKey.c_str(), strNextGroup.c_str()) != NULL ) 
            return iGetx2RCBool(strNextGroup, baseName, defaultVal);
        else
            return iGetxRCBool(strNextGroup, baseName, iGetxRCBool("Global", baseName, defaultVal));
    }
    else
    {
        return iGetxRCBool(uniqueKey, baseName, iGetxRCBool("Global", baseName, defaultVal));
    }
}

// retrieve a string value from step.rc
string iGetxRCString(const string &uniqueKey, const string &baseName, const string &defaultVal)
{
    string key = uniqueKey + baseName;

    char buffer[MAX_LINE_LENGTH] = {0};
    GetRCString(key.c_str(), buffer, defaultVal.c_str(), MAX_LINE_LENGTH);

    return (string) buffer;
}

// retrieve a string value from step.rc
string iGetx2RCString(const string &uniqueKey, const string &baseName, const string &defaultVal)
{
    if ( iGetxRCBool(uniqueKey, baseName) )
        return iGetxRCString(uniqueKey, baseName, defaultVal);

    string strGroups = iGetxRCLine(uniqueKey, "AddToGroup", "");
    string strNextGroup = "";

    if ( !strGroups.empty() )
    {
        char szBuffer[MAX_LINE_LENGTH] = {0};
        LPCSTR pszNextToken = strGroups.c_str();

        while ( GetToken(pszNextToken, szBuffer, &pszNextToken, false) )
        {
            if ( strNextGroup.empty() )
                strNextGroup = szBuffer;

            if ( iGetxRCBool(szBuffer, baseName) )
                return iGetxRCString(szBuffer, baseName, defaultVal);
        }

        if ( _stricmp(uniqueKey.c_str(), strNextGroup.c_str()) != NULL )
            return iGetx2RCString(strNextGroup, baseName, defaultVal);
        else
            return iGetxRCString(strNextGroup, baseName, iGetxRCString("Global", baseName, defaultVal));
    }
    else
    {
        return iGetxRCString(uniqueKey, baseName, iGetxRCString("Global", baseName, defaultVal));
    }
}

// retrieve a line from step.rc
string iGetxRCLine(const string &uniqueKey, const string &baseName, const string &defaultVal)
{
    string key = uniqueKey + baseName;

    char buffer[MAX_LINE_LENGTH] = {0};
    GetRCLine(key.c_str(), buffer, MAX_LINE_LENGTH, defaultVal.c_str());

    return (string) buffer;
}

// retrieve a line from step.rc
string iGetx2RCLine(const string &uniqueKey, const string &baseName, const string &defaultVal)
{
    if ( iGetxRCBool(uniqueKey, baseName) )
        return iGetxRCLine(uniqueKey, baseName, defaultVal);

    string strGroups = iGetxRCLine(uniqueKey, "AddToGroup", "");
    string strNextGroup = "";

    if ( !strGroups.empty() )
    {
        char szBuffer[MAX_LINE_LENGTH] = {0};
        LPCSTR pszNextToken = strGroups.c_str();

        while ( GetToken(pszNextToken, szBuffer, &pszNextToken, false) )
        {
            if ( strNextGroup.empty() )
                strNextGroup = szBuffer;

            if ( iGetxRCBool(szBuffer, baseName) )
                return iGetxRCLine(szBuffer, baseName, defaultVal);
        }

        if ( _stricmp(uniqueKey.c_str(), strNextGroup.c_str()) != NULL )
            return iGetx2RCLine(strNextGroup, baseName, defaultVal);
        else
            return iGetxRCLine(strNextGroup, baseName, iGetxRCLine("Global", baseName, defaultVal));
    }
    else
    {
        return iGetxRCLine(uniqueKey, baseName, iGetxRCLine("Global", baseName, defaultVal));
    }
}

// retrieve a named value from step.rc
int iGetxRCNamedValue(const string &uniqueKey, const string &baseName, const NameValuePair *nameValuePairs, int defaultVal)
{
    string name = iGetxRCString(uniqueKey, baseName, "");

    const NameValuePair *current = nameValuePairs;

    if(name.length() > 0)
    {
        while(current->name)
        {
            if(_stricmp(current->name, name.c_str()) == 0)
                return current->value;

            current++;
        }
    }

    return defaultVal;
}

// retrieve a named value from step.rc
int iGetx2RCNamedValue(const string &uniqueKey, const string &baseName, const NameValuePair *nameValuePairs, int defaultVal)
{
    if ( iGetxRCBool(uniqueKey, baseName) )
        return iGetxRCNamedValue(uniqueKey, baseName, nameValuePairs, defaultVal);

    string strGroups = iGetxRCLine(uniqueKey, "AddToGroup", "");
    string strNextGroup = "";

    if ( !strGroups.empty() )
    {
        char szBuffer[MAX_LINE_LENGTH] = {0};
        LPCSTR pszNextToken = strGroups.c_str();

        while ( GetToken(pszNextToken, szBuffer, &pszNextToken, false) )
        {
            if ( strNextGroup.empty() )
                strNextGroup = szBuffer;

            if ( iGetxRCBool(szBuffer, baseName) )
                return iGetxRCNamedValue(szBuffer, baseName, nameValuePairs, defaultVal);
        }

        if ( _stricmp(uniqueKey.c_str(), strNextGroup.c_str()) != NULL )
            return iGetx2RCNamedValue(strNextGroup, baseName, nameValuePairs, defaultVal);
        else
            return iGetxRCNamedValue(strNextGroup, baseName, nameValuePairs, iGetxRCNamedValue("Global", baseName, nameValuePairs, defaultVal));
    }
    else
    {
        return iGetxRCNamedValue(uniqueKey, baseName, nameValuePairs, iGetxRCNamedValue("Global", baseName, nameValuePairs, defaultVal));
    }
}

// retrieve a color value from step.rc
int iGetxRCColor(const string &uniqueKey, const string &baseName, int defaultVal)
{
    string key = uniqueKey + baseName;

    COLORREF crReturn = (COLORREF) defaultVal;

    char buffer[MAX_LINE_LENGTH] = {0};
    GetRCLine(key.c_str(), buffer, MAX_LINE_LENGTH, "");
    string tmpColor = buffer;

    if (tmpColor.empty())
        return crReturn;

    ProcessColor(tmpColor, crReturn);
    
    return crReturn;
}

// retrieve a color value from step.rc
int iGetx2RCColor(const string &uniqueKey, const string &baseName, int defaultVal)
{
    if ( iGetxRCBool(uniqueKey, baseName) )
        return iGetxRCColor(uniqueKey, baseName, defaultVal);

    string strGroups = iGetxRCLine(uniqueKey, "AddToGroup", "");
    string strNextGroup = "";

    if ( !strGroups.empty() )
    {
        char szBuffer[MAX_LINE_LENGTH] = {0};
        LPCSTR pszNextToken = strGroups.c_str();

        while ( GetToken(pszNextToken, szBuffer, &pszNextToken, false) )
        {
            if ( strNextGroup.empty() )
                strNextGroup = szBuffer;

            if ( iGetxRCBool(szBuffer, baseName) )
                return iGetxRCColor(szBuffer, baseName, defaultVal);
        }

        if ( _stricmp(uniqueKey.c_str(), strNextGroup.c_str()) != NULL )
            return iGetx2RCColor(strNextGroup, baseName, defaultVal);
        else
            return iGetxRCColor(strNextGroup, baseName, iGetxRCColor("Global", baseName, defaultVal));
    }
    else
    {
        return iGetxRCColor(uniqueKey, baseName, iGetxRCColor("Global", baseName, defaultVal));
    }
}

// retrieve an integer value from step.rc, make sure it is between minVal and maxVal inclusive
int iGetxRCInt(const string &uniqueKey, const string &baseName, int defaultVal, int minVal, int maxVal)
{
    string key = uniqueKey + baseName;
    int answer = GetRCInt(key.c_str(), defaultVal);
    return max(min(answer, maxVal), minVal);
}

// retrieve an integer value from step.rc, make sure it is between minVal and maxVal inclusive
int iGetx2RCInt(const string &uniqueKey, const string &baseName, int defaultVal, int minVal, int maxVal)
{
    if ( iGetxRCBool(uniqueKey, baseName) )
        return iGetxRCInt(uniqueKey, baseName, defaultVal, minVal, maxVal);

    string strGroups = iGetxRCLine(uniqueKey, "AddToGroup", "");
    string strNextGroup = "";

    if ( !strGroups.empty() )
    {
        char szBuffer[MAX_LINE_LENGTH] = {0};
        LPCSTR pszNextToken = strGroups.c_str();

        while ( GetToken(pszNextToken, szBuffer, &pszNextToken, false) )
        {
            if ( strNextGroup.empty() )
                strNextGroup = szBuffer;

            if ( iGetxRCBool(szBuffer, baseName) )
                return iGetxRCInt(szBuffer, baseName, defaultVal, minVal, maxVal);
        }

        if ( _stricmp(uniqueKey.c_str(), strNextGroup.c_str()) != NULL )
            return iGetx2RCInt(strNextGroup, baseName, defaultVal, minVal, maxVal);
        else
            return iGetxRCInt(strNextGroup, baseName, iGetxRCInt("Global", baseName, defaultVal, minVal, maxVal), minVal, maxVal);
    }
    else
    {
        return iGetxRCInt(uniqueKey, baseName, iGetxRCInt("Global", baseName, defaultVal, minVal, maxVal), minVal, maxVal);
    }
}

// parse a coordinate specification
int ixParseCoord(const string &aString, int defaultVal, int maxVal, bool bYCoordinate)
{
    string strVal = trim(aString);

    if (strVal.length() == 0)
        return defaultVal;

    bool negative = false;
    bool percentage = false;
    bool extendedpercentage = false;
    bool realnegative = false;
    bool center = false;
    UINT i = 0;
    int value = 0;
    int extendedvalue = 0;

    if ( multimonitor.iRealMonitors > 1 && strstr(strVal.c_str(), "@") != NULL )
    {
        int minx = 0;
        int miny = 0;
        int maxwidth = maxVal;
        int maxheight = maxVal;
        if ( strstr(strVal.c_str(), "@") != NULL && (strVal[i] == 'v' || strVal[i] == 'V') && multimonitor.iRealMonitors >= 2 )
        {
            minx = multimonitor.iMinScreenX;
            miny = multimonitor.iMinScreenY;
            maxwidth = multimonitor.iMaxScreenWidth;
            maxheight = multimonitor.iMaxScreenHeight;
        }
        else if ( strstr(strVal.c_str(), "@") != NULL && strVal[i] == '2' && multimonitor.iRealMonitors >= 2 )
        {
            for (int x = 0; x < multimonitor.iMonitorIndex; x++)
            {
                if ( multimonitor.MonitorInfoArray[x].dwFlags != MONITORINFOF_PRIMARY )
                {
                    minx = multimonitor.MonitorInfoArray[x].rcMonitor.left;
                    miny = multimonitor.MonitorInfoArray[x].rcMonitor.top;
                    maxwidth = multimonitor.MonitorSizeArray[x].cx;
                    maxheight = multimonitor.MonitorSizeArray[x].cy;

                    break;
                }
            }
        }
        else if ( strstr(strVal.c_str(), "@") != NULL && strVal[i] == '3' && multimonitor.iRealMonitors >= 3 )
        {
            int skip = 1;
            for (int x = 0; x < multimonitor.iMonitorIndex; x++)
            {
                if ( multimonitor.MonitorInfoArray[x].dwFlags != MONITORINFOF_PRIMARY )
                {
                    if ( skip > 0 )
                    {
                        skip--;
                        continue;
                    }
                    
                    minx = multimonitor.MonitorInfoArray[x].rcMonitor.left;
                    miny = multimonitor.MonitorInfoArray[x].rcMonitor.top;
                    maxwidth = multimonitor.MonitorSizeArray[x].cx;
                    maxheight = multimonitor.MonitorSizeArray[x].cy;

                    break;
                }
            }
        }
		else if ( strstr(strVal.c_str(), "@") != NULL && (strVal[i] == 'a' || strVal[i] == 'A') && multimonitor.iRealMonitors >= 2 )
        {
            minx = multimonitor.MonitorInfoArray[0].rcMonitor.left;
            miny = multimonitor.MonitorInfoArray[0].rcMonitor.top;
            maxwidth = multimonitor.MonitorSizeArray[0].cx;
            maxheight = multimonitor.MonitorSizeArray[0].cy;
        }
		else if ( strstr(strVal.c_str(), "@") != NULL && (strVal[i] == 'b' || strVal[i] == 'B') && multimonitor.iRealMonitors >= 2 )
        {
            minx = multimonitor.MonitorInfoArray[1].rcMonitor.left;
            miny = multimonitor.MonitorInfoArray[1].rcMonitor.top;
            maxwidth = multimonitor.MonitorSizeArray[1].cx;
            maxheight = multimonitor.MonitorSizeArray[1].cy;
        }
		else if ( strstr(strVal.c_str(), "@") != NULL && (strVal[i] == 'c' || strVal[i] == 'C') && multimonitor.iRealMonitors >= 3 )
        {
            minx = multimonitor.MonitorInfoArray[2].rcMonitor.left;
            miny = multimonitor.MonitorInfoArray[2].rcMonitor.top;
            maxwidth = multimonitor.MonitorSizeArray[2].cx;
            maxheight = multimonitor.MonitorSizeArray[2].cy;
        }
        else
        {
            for (int x = 0; x < multimonitor.iMonitorIndex; x++)
            {
                if ( multimonitor.MonitorInfoArray[x].dwFlags == MONITORINFOF_PRIMARY )
                {
                    minx = multimonitor.MonitorInfoArray[x].rcMonitor.left;
                    miny = multimonitor.MonitorInfoArray[x].rcMonitor.top;
                    maxwidth = multimonitor.MonitorSizeArray[x].cx;
                    maxheight = multimonitor.MonitorSizeArray[x].cy;

                    break;
                }
            }
        }
        
        if ( strstr(strVal.c_str(), "@") != NULL )
            i = i+2;

        if (strVal[i] == '-')
        {
            negative = true;
            i++;
        }
        else if (strVal[i] == '~')
        {
            realnegative = true;
            i++;
        }
        else if (strVal[i] == '+')
        {
            i++;
        }

        while (i < strVal.length())
        {
            if(strVal[i] >= '0' && strVal[i] <= '9')
            {
                value = (value * 10) + (strVal[i] - '0');
            }
            else
            {
                if(strVal[i] == 'c' || strVal[i] == 'C')
                {
                    center = true;
                }
                else if (strVal[i] == '%')
                {
                    percentage = true;

                    if (strVal[i+1] == '+' )
                    {
                        extendedpercentage = true;
                        i++;

                        while (i < strVal.length())
                        {
                            if (strVal[i] >= '0' && strVal[i] <= '9')
                            {
                                extendedvalue = (extendedvalue * 10) + (strVal[i] - '0');
                            }
                            i++;
                        }
                    }
                    else if (strVal[i+1] == '-' )
                    {
                        extendedpercentage = true;
                        i++;

                        while (i < strVal.length())
                        {
                            if (strVal[i] >= '0' && strVal[i] <= '9')
                            {
                                extendedvalue = (extendedvalue * 10) + (strVal[i] - '0');
                            }
                            i++;
                        }
                        extendedvalue = extendedvalue*(-1);
                    }
                }
                break;
            }

            i++;
        }

        if (center)
        {
            if (realnegative)
                negative = true;

            if (negative)
                value = (bYCoordinate ? miny+(maxheight/2) : minx+(maxwidth/2)) - value;
            else
                value = (bYCoordinate ? miny+(maxheight/2) : minx+(maxwidth/2)) + value;
        }
        else if (realnegative)
        {
            value = (bYCoordinate ? miny : minx) - value;
        }
        else if (negative)
        {
            value = (bYCoordinate ? miny+maxheight : minx+maxwidth) - value;
        }
        else if (percentage)
        {
            value = (value * (bYCoordinate ? maxheight : maxwidth)) / 100;
            if (extendedpercentage)
                value = value + extendedvalue;
        }
        else
        {
            value = (bYCoordinate ? miny : minx) + value;
        }
    }
    else
    {
        if ( strstr(strVal.c_str(), "@") != NULL )
            i = i+2;

        if (strVal[i] == '-')
        {
            negative = true;
            i++;
        }
        else if (strVal[i] == '~')
        {
            realnegative = true;
            i++;
        }
        else if (strVal[i] == '+')
        {
            i++;
        }

        while (i < strVal.length())
        {
            if(strVal[i] >= '0' && strVal[i] <= '9')
            {
                value = (value * 10) + (strVal[i] - '0');
            }
            else
            {
                if(strVal[i] == 'c' || strVal[i] == 'C')
                {
                    center = true;
                }
                else if (strVal[i] == '%')
                {
                    percentage = true;

                    if (strVal[i+1] == '+' )
                    {
                        extendedpercentage = true;
                        i++;

                        while (i < strVal.length())
                        {
                            if (strVal[i] >= '0' && strVal[i] <= '9')
                            {
                                extendedvalue = (extendedvalue * 10) + (strVal[i] - '0');
                            }
                            i++;
                        }
                    }
                    else if (strVal[i+1] == '-' )
                    {
                        extendedpercentage = true;
                        i++;

                        while (i < strVal.length())
                        {
                            if (strVal[i] >= '0' && strVal[i] <= '9')
                            {
                                extendedvalue = (extendedvalue * 10) + (strVal[i] - '0');
                            }
                            i++;
                        }
                        extendedvalue = extendedvalue*(-1);
                    }
                }
                break;
            }

            i++;
        }

        if (center)
        {
            if (realnegative)
                negative = true;

            if (negative)
                value = (maxVal/2) - value;
            else
                value = (maxVal/2) + value;
        }
        else if (realnegative)
        {
            value = -value;
        }
        else if (negative)
        {
            value = maxVal - value;
        }
        else if (percentage)
        {
            value = (value * maxVal) / 100;
            if (extendedpercentage)
                value = value + extendedvalue;
        }
    }
    
    return value;
}

// retrieve a coordinate from step.rc, accounting for negative values and centering
int iGetxRCCoord(const string &uniqueKey, const string &baseName, int defaultVal, int maxVal, bool bYCoordinate)
{
    string strVal = iGetxRCString(uniqueKey, baseName, "");
    return ixParseCoord(strVal, defaultVal, maxVal, bYCoordinate);
}

int iGetx2RCCoord(const string &uniqueKey, const string &baseName, int defaultVal, int maxVal, bool bYCoordinate)
{
    if ( iGetxRCBool(uniqueKey, baseName) )
        return iGetxRCCoord(uniqueKey, baseName, defaultVal, maxVal, bYCoordinate);

    string strGroups = iGetxRCLine(uniqueKey, "AddToGroup", "");
    string strNextGroup = "";

    if ( !strGroups.empty() )
    {
        char szBuffer[MAX_LINE_LENGTH] = {0};
        LPCSTR pszNextToken = strGroups.c_str();

        while ( GetToken(pszNextToken, szBuffer, &pszNextToken, false) )
        {
            if ( strNextGroup.empty() )
                strNextGroup = szBuffer;

            if ( iGetxRCBool(szBuffer, baseName) )
                return iGetxRCCoord(szBuffer, baseName, defaultVal, maxVal, bYCoordinate);
        }

        if ( _stricmp(uniqueKey.c_str(), strNextGroup.c_str()) != NULL )
            return iGetx2RCCoord(strNextGroup, baseName, defaultVal, maxVal, bYCoordinate);
        else
            return iGetxRCCoord(strNextGroup, baseName, iGetxRCCoord("Global", baseName, defaultVal, maxVal, bYCoordinate), maxVal, bYCoordinate);
    }
    else
    {
        return iGetxRCCoord(uniqueKey, baseName, iGetxRCCoord("Global", baseName, defaultVal, maxVal, bYCoordinate), maxVal, bYCoordinate);
    }
}

// parse a dimension
int ixParseDimen(const string &aString, int defaultVal, int maxVal, bool bYCoordinate)
{   
    string strVal = trim(aString);

    if (strVal.length() == 0)
        return defaultVal;

    bool negative = false;
    bool percentage = false;
    bool extendedpercentage = false;
    UINT i = 0;
    int value = 0;
    int extendedvalue = 0;

    if ( multimonitor.iRealMonitors > 1 && strstr(strVal.c_str(), "@") != NULL )
    {
        int maxwidth = maxVal;
        int maxheight = maxVal;
        if ( strstr(strVal.c_str(), "@") != NULL && (strVal[i] == 'v' || strVal[i] == 'V') && multimonitor.iRealMonitors >= 2 )
        {
            maxwidth = multimonitor.iMaxScreenWidth;
            maxheight = multimonitor.iMaxScreenHeight;
        }
        else if ( strstr(strVal.c_str(), "@") != NULL && strVal[i] == '2' && multimonitor.iRealMonitors >= 2 )
        {
            for (int x = 0; x < multimonitor.iMonitorIndex; x++)
            {
                if ( multimonitor.MonitorInfoArray[x].dwFlags != MONITORINFOF_PRIMARY )
                {
                    maxwidth = multimonitor.MonitorSizeArray[x].cx;
                    maxheight = multimonitor.MonitorSizeArray[x].cy;

                    break;
                }
            }
        }
        else if ( strstr(strVal.c_str(), "@") != NULL && strVal[i] == '3' && multimonitor.iRealMonitors >= 3 )
        {
            int skip = 1;
            for (int x = 0; x < multimonitor.iMonitorIndex; x++)
            {
                if ( multimonitor.MonitorInfoArray[x].dwFlags != MONITORINFOF_PRIMARY )
                {
                    if ( skip > 0 )
                    {
                        skip--;
                        continue;
                    }
            
                    maxwidth = multimonitor.MonitorSizeArray[x].cx;
                    maxheight = multimonitor.MonitorSizeArray[x].cy;

                    break;
                }
            }
        }
		else if ( strstr(strVal.c_str(), "@") != NULL && (strVal[i] == 'a' || strVal[i] == 'A') && multimonitor.iRealMonitors >= 2 )
        {
            maxwidth = multimonitor.MonitorSizeArray[0].cx;
            maxheight = multimonitor.MonitorSizeArray[0].cy;
        }
		else if ( strstr(strVal.c_str(), "@") != NULL && (strVal[i] == 'b' || strVal[i] == 'B') && multimonitor.iRealMonitors >= 2 )
        {
            maxwidth = multimonitor.MonitorSizeArray[1].cx;
            maxheight = multimonitor.MonitorSizeArray[1].cy;
        }
		else if ( strstr(strVal.c_str(), "@") != NULL && (strVal[i] == 'c' || strVal[i] == 'C') && multimonitor.iRealMonitors >= 3 )
        {
            maxwidth = multimonitor.MonitorSizeArray[2].cx;
            maxheight = multimonitor.MonitorSizeArray[2].cy;
        }
        else
        {
            for (int x = 0; x < multimonitor.iMonitorIndex; x++)
            {
                if ( multimonitor.MonitorInfoArray[x].dwFlags == MONITORINFOF_PRIMARY )
                {
                    maxwidth = multimonitor.MonitorSizeArray[x].cx;
                    maxheight = multimonitor.MonitorSizeArray[x].cy;

                    break;
                }
            }
        }

        if ( strstr(strVal.c_str(), "@") != NULL )
            i = i+2;

        if (strVal[i] == '-')
        {
            negative = true;
            i++;
        }

        while (i < strVal.length())
        {
            if (strVal[i] >= '0' && strVal[i] <= '9')
            {
                value = (value * 10) + (strVal[i] - '0');
            }
            else
            {
                if (strVal[i] == '%')
                    percentage = true;

                if (strVal[i+1] == '+' )
                {
                    extendedpercentage = true;
                    i++;

                    while (i < strVal.length())
                    {
                        if (strVal[i] >= '0' && strVal[i] <= '9')
                        {
                            extendedvalue = (extendedvalue * 10) + (strVal[i] - '0');
                        }
                        i++;
                    }
                }
                else if (strVal[i+1] == '-' )
                {
                    extendedpercentage = true;
                    i++;

                    while (i < strVal.length())
                    {
                        if (strVal[i] >= '0' && strVal[i] <= '9')
                        {
                            extendedvalue = (extendedvalue * 10) + (strVal[i] - '0');
                        }
                        i++;
                    }
                    extendedvalue = extendedvalue*(-1);
                }

                break;
            }

            i++;
        }

        if (percentage)
        {
            value = (value * (bYCoordinate ? maxheight : maxwidth)) / 100;
            if (extendedpercentage)
                value = value + extendedvalue;
        }

        if (negative)
            value = (bYCoordinate ? maxheight : maxwidth) - value;
    }
    else
    {
        if ( strstr(strVal.c_str(), "@") != NULL )
            i = i+2;

        if (strVal[i] == '-')
        {
            negative = true;
            i++;
        }

        while (i < strVal.length())
        {
            if (strVal[i] >= '0' && strVal[i] <= '9')
            {
                value = (value * 10) + (strVal[i] - '0');
            }
            else
            {
                if (strVal[i] == '%')
                    percentage = true;

                if (strVal[i+1] == '+' )
                {
                    extendedpercentage = true;
                    i++;

                    while (i < strVal.length())
                    {
                        if (strVal[i] >= '0' && strVal[i] <= '9')
                        {
                            extendedvalue = (extendedvalue * 10) + (strVal[i] - '0');
                        }
                        i++;
                    }
                }
                else if (strVal[i+1] == '-' )
                {
                    extendedpercentage = true;
                    i++;

                    while (i < strVal.length())
                    {
                        if (strVal[i] >= '0' && strVal[i] <= '9')
                        {
                            extendedvalue = (extendedvalue * 10) + (strVal[i] - '0');
                        }
                        i++;
                    }
                    extendedvalue = extendedvalue*(-1);
                }

                break;
            }

            i++;
        }

        if (percentage)
        {
            value = (value * maxVal) / 100;
            if (extendedpercentage)
                value = value + extendedvalue;
        }

        if (negative)
            value = maxVal - value;
    }
    
    return value;
}

// retrieve a dimension (absolute value or percentage) from step.rc
int iGetxRCDimen(const string &uniqueKey, const string &baseName, int defaultVal, int maxVal, bool bYCoordinate)
{
    string strVal = iGetxRCString(uniqueKey, baseName, "");

    if (_stricmp(strVal.c_str(), ".image") == NULL)
        return defaultVal;
    else
        return ixParseDimen(strVal, defaultVal, maxVal, bYCoordinate);
}

// retrieve a dimension (absolute value or percentage) from step.rc
int iGetx2RCDimen(const string &uniqueKey, const string &baseName, int defaultVal, int maxVal, bool bYCoordinate)
{
    if ( iGetxRCBool(uniqueKey, baseName) )
        return iGetxRCDimen(uniqueKey, baseName, defaultVal, maxVal, bYCoordinate);

    string strGroups = iGetxRCLine(uniqueKey, "AddToGroup", "");
    string strNextGroup = "";

    if ( !strGroups.empty() )
    {
        char szBuffer[MAX_LINE_LENGTH] = {0};
        LPCSTR pszNextToken = strGroups.c_str();

        while ( GetToken(pszNextToken, szBuffer, &pszNextToken, false) )
        {
            if ( strNextGroup.empty() )
                strNextGroup = szBuffer;

            if ( iGetxRCBool(szBuffer, baseName) )
                return iGetxRCDimen(szBuffer, baseName, defaultVal, maxVal, bYCoordinate);
        }

        if ( _stricmp(uniqueKey.c_str(), strNextGroup.c_str()) != NULL )
            return iGetx2RCDimen(strNextGroup, baseName, defaultVal, maxVal, bYCoordinate);
        else
            return iGetxRCDimen(strNextGroup, baseName, iGetxRCDimen("Global", baseName, defaultVal, maxVal, bYCoordinate), maxVal, bYCoordinate);
    }
    else
    {
        return iGetxRCDimen(uniqueKey, baseName, iGetxRCDimen("Global", baseName, defaultVal, maxVal, bYCoordinate), maxVal, bYCoordinate);
    }
}

int SplitString(const string &process, string &one, string &two, string &three, string &four, string &five, string &six, string &seven)
{
    int count = 0;

    one = "";
    two = "";
    three = "";
    four = "";
    five = "";
    six = "";
    seven = "";

    char cone[256] = {0};
    char ctwo[256] = {0};
    char cthree[256] = {0};
    char cfour[256] = {0};
    char cfive[256] = {0};
    char csix[256] = {0};
    char cseven[256] = {0};
    char *cbuffers[] = {cone, ctwo, cthree, cfour, cfive, csix, cseven};
        
    int numTokens = LCTokenize(process.c_str(), cbuffers, 7, NULL);
    
    if( numTokens >= 1 )
    {
        one = cone;
        count++;
        
        if ( numTokens >= 2 )
        {
            two = ctwo;
            count++;
        
            if ( numTokens >= 3 )
            {
                three = cthree;
                count++;
            
                if ( numTokens >= 4 )
                {
                    four = cfour;
                    count++;

                    if ( numTokens >= 5 )
                    {
                        five = cfive;
                        count++;

                        if ( numTokens >= 6 )
                        {
                            six = csix;
                            count++;
        
                            if ( numTokens >= 7 )
                            {
                                seven = cseven;
                                count++;
                            }
                        }
                    }
                }
            }
        }
    }

    return count;
}

//////////////////////////////////////////////////////////////////////
// Exported in xExports.h
//////////////////////////////////////////////////////////////////////

BOOL GetxRCBool(LPCSTR uniqueKey, LPCSTR baseName, BOOL defaultVal)
{
    return (iGetxRCBool(uniqueKey, baseName, (defaultVal ? true : false)) ? TRUE : FALSE);
}

BOOL Getx2RCBool(LPCSTR uniqueKey, LPCSTR baseName, BOOL defaultVal)
{
    return (iGetx2RCBool(uniqueKey, baseName, (defaultVal ? true : false)) ? TRUE : FALSE);
}

void GetxRCString(LPSTR pszValue, LPCSTR uniqueKey, LPCSTR baseName, LPCSTR defaultVal)
{
    StringCchCopy(pszValue, 4096, (iGetxRCString(uniqueKey, baseName, defaultVal)).c_str()); 
}
void Getx2RCString(LPSTR pszValue, LPCSTR uniqueKey, LPCSTR baseName, LPCSTR defaultVal)
{
    StringCchCopy(pszValue, 4096, (iGetx2RCString(uniqueKey, baseName, defaultVal)).c_str());
}

void GetxRCLine(LPSTR pszValue, LPCSTR uniqueKey, LPCSTR baseName, LPCSTR defaultVal)
{
    StringCchCopy(pszValue, 4096, (iGetxRCLine(uniqueKey, baseName, defaultVal)).c_str());
}
void Getx2RCLine(LPSTR pszValue, LPCSTR uniqueKey, LPCSTR baseName, LPCSTR defaultVal)
{
    StringCchCopy(pszValue, 4096, (iGetx2RCLine(uniqueKey, baseName, defaultVal)).c_str());
}

int GetxRCNamedValue(LPCSTR uniqueKey, LPCSTR baseName, const NameValuePair *nameValuePairs, int defaultVal)
{
    return iGetxRCNamedValue(uniqueKey, baseName, nameValuePairs, defaultVal);
}
int Getx2RCNamedValue(LPCSTR uniqueKey, LPCSTR baseName, const NameValuePair *nameValuePairs, int defaultVal)
{
    return iGetx2RCNamedValue(uniqueKey, baseName, nameValuePairs, defaultVal);
}

int GetxRCColor(LPCSTR uniqueKey, LPCSTR baseName, int defaultVal)
{
    return iGetxRCColor(uniqueKey, baseName, defaultVal);
}
int Getx2RCColor(LPCSTR uniqueKey, LPCSTR baseName, int defaultVal)
{
    return iGetx2RCColor(uniqueKey, baseName, defaultVal);
}

int GetxRCInt(LPCSTR uniqueKey, LPCSTR baseName, int defaultVal, int minVal, int maxVal)
{
    return iGetxRCInt(uniqueKey, baseName, defaultVal, minVal, maxVal);
}
int Getx2RCInt(LPCSTR uniqueKey, LPCSTR baseName, int defaultVal, int minVal, int maxVal)
{
    return iGetx2RCInt(uniqueKey, baseName, defaultVal, minVal, maxVal);
}

int xParseCoord(LPCSTR aString, int defaultVal, int maxVal, BOOL bYCoordinate)
{
    return ixParseCoord(aString, defaultVal, maxVal, (bYCoordinate ? true : false));
}
int GetxRCCoord(LPCSTR uniqueKey, LPCSTR baseName, int defaultVal, int maxVal, BOOL bYCoordinate)
{
    return iGetxRCCoord(uniqueKey, baseName, defaultVal, maxVal, (bYCoordinate ? true : false));
}
int Getx2RCCoord(LPCSTR uniqueKey, LPCSTR baseName, int defaultVal, int maxVal, BOOL bYCoordinate)
{
    return iGetx2RCCoord(uniqueKey, baseName, defaultVal, maxVal, (bYCoordinate ? true : false));
}

int xParseDimen(LPCSTR aString, int defaultVal, int maxVal, BOOL bYCoordinate)
{
    return ixParseDimen(aString, defaultVal, maxVal, (bYCoordinate ? true : false));
}

int GetxRCDimen(LPCSTR uniqueKey, LPCSTR baseName, int defaultVal, int maxVal, BOOL bYCoordinate)
{
    return iGetxRCDimen(uniqueKey, baseName, defaultVal, maxVal, (bYCoordinate ? true : false));
}
int Getx2RCDimen(LPCSTR uniqueKey, LPCSTR baseName, int defaultVal, int maxVal, BOOL bYCoordinate)
{
    return iGetx2RCDimen(uniqueKey, baseName, defaultVal, maxVal, (bYCoordinate ? true : false));
}
